*! 1.0.0 2013-08-29 | long freese | renamed to mchange1 replaced by v2

//  discrete change using margins

capture program drop mchange
capture program drop parse_amt
capture program drop parse_stat
program define mchange1, rclass

    version 11.2
    syntax [varlist(default=none fv)] [if] [in] ,  ///
        [                               ///
        allow12 /// allow version 12 to not use at(x=gen()) evenin Stata 13
        MATrix(string) /// name for saving r(table)
        AMount(string) AMOUNTBinary(string) ///
            /// range binary one sd marginal all
        BYSTATistics /// show results in one stat per table
        ATMEANs /// use atmean option for margins
        DECimals(numlist >-1 integer) /// dec # in output
        WIDth(numlist >5 integer) /// width in output
        DESCriptives /// descriptive statistics
        /// MARGINSoptions(string asis) /// passthrough to margins
        OUTcome(string) /// user can specify outcomes TO BE ADDED
        STATS(string asis) /// synonym for statistics
        STATistics(string asis) /// change ul ll z se p start end
        UNCENtered /// uncentered change
        DETails /// list margins output
        COMMANDs /// list commands
        at(string) /// added to end of at()
        brief ///
        delta(real 0) /// delta change instead of sd change
        replace /// replace matrix
        title(string) /// matrix title
        trim(numlist >-1 integer) /// percent to trim from min max
        * ///
        ]

display in blue "Note: use {cmd:mchange}; this version is obsolete | 2013-08-29"

    tempname change b se z pvalue ll ul lvl start end _at mat
    tempname v blank1var blank1varR blankallvars pbase varinfo betainfo
    tempname _PWprob _PWprobsrc temp tempmat
    tempname vecis vec_desc mat_desc selmat
    tempname _all_end _all_start _all_se _all_z _all_ll
    tempname _all_ul _all_pvalue _all_change
    tempname _prt_end _prt_start _prt_se _prt_z _prt_ll
    tempname _prt_ul _prt_pvalue _prt_change _prt _byvar
    tempvar predvar varinsamp origvar predictF predictT predictDC
    tempvar varsd_DC varsd_F varsd_T varone_DC varone_F varone_T
    local error = 0

    if "`e(cmd)'"=="" | "`e(cmd)'"=="margins" {
        display as error "no estimation command is in memory"
        exit
    }
    estimates store _mchange_model // last model estiamted

    local dropmat = 1 // change to 0 to keep working matrices in memory
    local use_predict "no" // use predict for AME's
    local S_all "change pvalue ul ll z se start end"

    * if allow_stata12 is no, use stata 13 at(gen()) even under version
    * control to avoide slow estimation of AME in Stata 12 and earlier
    local allow_stata12 "yes"
    if (_caller()>=13) local allow_stata12 "no"
    capture (if c(stata_version)>=13 & "`allow12'"=="") local allow_stata12 "no"

    * prevents duplication of effects when mchange i.k5 is entered
    local varlist : subinstr local varlist "i." "", all
    * syntax converts 2.cat 3.cat etc to i(2 3 etc).cat; this unexpands it
    fvexpand `varlist'
    local varlist `r(varlist)'
    local varlist : subinstr local varlist "b." ".", all

//  synonyms

    local amount : subinstr local amount "delta" "sd", all
    local amountbin "`amountbinary'" // shorten name
    if ("`amount'"=="all") local amount "rng bin one sd marg"
    if ("`stats'"!="" & "`statistics'"=="") local statistics "`stats'"
    if ("`statistics'"=="ci") local statistics "change ll ul"
    if "`statistics'"=="all" {
        local statistics "change ul ll z se pvalue start end"
    }

//  evaluate amount and stat abbreviations

    local isbad = 0
    if "`amount'"!="" { // amounts for continuous variables
        local new ""
        foreach anm in `amount' {
            parse_amt `anm'
            local newanm
            local amt "`s(amount)'"
            local new "`new'`amt' "
            if "`s(isbad)'"=="1" {
                display as error "invalid amount specified: `anm'"
                local isbad = 1
                exit
            }
        }
        local amount "`new'"
    }

    if "`amountbin'"!="" { // amount for binary variables
        local new ""
        foreach anm in `amountbin' {
            parse_amt `anm'
            local newanm
            local amt "`s(amount)'"
            local new "`new'`amt' "
            if "`s(isbad)'"=="1" {
                display as error "invalid amount specified: `anm'"
                local isbad = 1
                exit
            }
        }
        local amountbin "`new'"
    }

    if "`statistics'"!="" { // select statistics
        local new ""
        foreach Snm in `statistics' {
            parse_stat `Snm'
            local newsnm
            local stat "`s(stat)'"
            local new "`new'`stat' "
            if "`s(isbad)'"=="1" {
                display as error "invalid statistic specified: `Snm'"
                local isbad = 1
                exit
            }
        }
        local statistics "`new'"
    }
    if ("`isbad'"=="1") exit

//  information about estimation command and type of predictor variables

    _rm_modelinfo
    local mdlTITLE "`r(cmdnm)'"
    local is_svy = `r(cmdsvy)'
    if (`is_svy') local mdlTITLE "svy `mdlTITLE'"
    local mdlBRM = `r(cmdbin)'
    local lhsncats = `r(lhscatn)'
    local lhsnm "`r(lhsnm)'"
    local lhscatnms "`r(lhscatnms)'"
    local mdlCRM = `r(cmdcrm)' // count model
    if (`mdlCRM') local lhsncats = 1
    if (`mdlCRM') local lhscatnms "Rate"
    local lhscatvals "`r(lhscatvals)'"
    if (`mdlBRM' | `mdlCRM') local lhscatvals "1"

    * regressor information
    matrix `varinfo' = r(varinfo)
    matrix `betainfo' = r(betainfo)
    local varinfonms : colnames `varinfo'
    local betainfonms : colnames `betainfo'
    * varnms correspond are expanded factor names (e.g., 1.hc)
    local varnms "`r(rhsnms)'"
    * change 1.x to i1.x which margins doesn't like...
    forvalues i = 0/20 {
        local varlist : subinstr local varlist "i`i'." "`i'.", all
    }

    * if varlist, get all fv's with variable name included
    if "`varlist'" != "" { // 2013-08-01 097
        local newvarlist ""
        local nbnms : list sizeof betainfonms
        foreach inputnm in `varlist' {
            local newvarlist "`newvarlist'`inputnm' "
            forvalues i=1/`nbnms' {
                * name of e(b) coef
                local betanm : word `i' of `betainfonms'
                * replaces 0b.<varnm> with #.<varnm>
                * without this, 0b.hc is sent to margins
                _ms_extract_varlist `betanm', noomit nofatal // eq(#)
                local betanm `r(varlist)'
                local ipos = strpos("`betanm'","`inputnm'")
                if `ipos'>0 { //
                    local addnm `betanm'
                    local newvarlist "`newvarlist'`addnm' "
                }
            }
        } // loop through input names
        local varlist "`newvarlist'"
        local varlist : list uniq varlist
    }

    if ("`varlist'"!="") local varnms "`varlist'"
    local nvarnms = wordcount("`varnms'")

//  decode options and create footnotes

    if `mdlBRM' & "`bystatistics'"=="bystatistics" {
        display "Note: option bystatistics does not work with binary models"
        local bystatistics ""
    }

    local qui "quietly"
    local quicmd "quietly" // qui listing of command
    if "`details'" == "details" {
        local qui "noisily"
        local quicmd "noisily"
        local commands "commands" // if detail, list commands
    }
    if ("`commands'"=="commands") local quicmd "noisily"

    local NOTEsample ""
    if ("`if'"=="") local if "if e(sample)==1"
    else local if "`if' & e(sample)==1"
    if "`if'"!="" & "`if'"!="if e(sample)==1" {
        local NOTEsample " Sample selection: `if'"
    }
    if "`in'" !="" {
        if ("`NOTEsample'"=="") local NOTEsample " Sample selection `in'"
        else local NOTEsample "`NOTEsample' `in'"
    }

    if ("`trim'"=="") local trim = 0
    if (`trim'==0) local NOTEtrim "Range is not trimmed."
    if (`trim'!=0) local NOTEtrim "Range trimmed by `trim' percent."

    local NOTEdelata ""
    if (`delta'!=0) local NOTEdelata "Delta equals `delta'."

    if ("`decimals'"=="") local decimals = 3 // to match pr commands
    if ("`width'"=="") local width = 9
    local twid = 12

    if ("`uncentered'"=="uncentered") local cntr_nm "unctr"
    else local cntr_nm "cntr"

    if (`delta'!=0) local sd_nm "delta"
    else local sd_nm "SD"

    local nobs = _N // # of rows in dataset

    * information at at() specification
    local ATinput "`at'" // at specification

//  amounts and their labels

    * amount labels for output
    local Clbl_bin "0_to_1"
    local Clbl_one "+1_`cntr_nm'"
    local Clbl_sd "+`sd_nm'_`cntr_nm'"
    local Clbl_marg "Marginal"
    local trimto = 100 - `trim'
    if (`trim'==0) local Clbl_rng "Range"
    else local Clbl_rng "`trim'%_to_`trimto'%"

    * amount sets
    local Cset_all "bin one sd rng marg" // all types in print order
    local Cset_dc  "bin one sd rng" // all dc types
    local Cset_bin "bin" // default for binary

    * mchange options for default amunts
    if ("`amountbin'"!="") local Cset_bin "`amountbin'"
    local Cset_con "one sd marg" // default for continuous
    if ("`amount'"!="") local Cset_con "`amount'"

    * which amounts to show
    local Cprt_bin "`Cset_bin'"
    local Cprt_con "`Cset_con'"
    local ipos : list posof "rng" in Cprt_con
    local C_isrng = `ipos'>0
    local Cprt_binNOdy = subinword("`Cprt_bin'", "marg", "", .)
    local Cprt_conNOdy = subinword("`Cprt_con'", "marg", "", .)

    * AME of +1 or +SD atmean pre Stata 13 uses predict
    foreach Cnm in `Cprt_con' {
        if ("`Cnm'"=="one" | "`Cnm'"=="sd" ) ///
            & ("`atmeans'"!="atmeans") & ("`allow_stata12'"=="yes") {
                local use_predict "yes"
        }
    }

    * amount matrix row offsets for specific amounts
    local Cmat_order "rng bin one sd marg" // row order in matrix
    local offset_rng  = 1
    local offset_bin  = 2
    local offset_one  = 3
    local offset_sd   = 4
    local offset_marg = 5

    * amount matrix row names in order defined above
    local Crownms `""`Clbl_rng'" "`Clbl_bin'""'
    local Crownms `"`Crownms' "`Clbl_one'" "`Clbl_sd'" "`Clbl_marg'""'
    * _ for space in labels
    local Crownms_ : subinstr local Crownms " " "_", all
    local Crownms_ : subinstr local Crownms_ `"_""' `" ""', all
    local Crownms_ : subinstr local Crownms_ `""_"' `"" "', all

    * row names using Range, not trim if trim is used
    local CrownmsR `""Range" "`Clbl_bin'""'
    local CrownmsR `"`CrownmsR' "`Clbl_one'" "`Clbl_sd'" "`Clbl_marg'""'
    local CrownmsR_ : subinstr local CrownmsR " " "_", all
    local CrownmsR_ : subinstr local CrownmsR_ `"_""' `" ""', all
    local CrownmsR_ : subinstr local CrownmsR_ `""_"' `"" "', all

    * offsets for printing each type of change
    local irowbin = 0
    local irowcon = 0
    foreach Cnm in `Cmat_order' {
        local ipos : list posof "`Cnm'" in Cprt_bin
        if `ipos'>0 {
            local ++irowbin
            local prtbin_off_`Cnm' = `irowbin'
        }
        else local prtbin_off_`Cnm' = 0
        local ipos : list posof "`Cnm'" in Cprt_con
        if `ipos'>0 {
            local ++irowcon
            local prtcon_off_`Cnm' = `irowcon'
        }
        else local prtcon_off_`Cnm' = 0
    }

//  classify beta estimates based on type of variable
//    : i.catvar handled with margins, pwcompare
//    : a#b only processed if it is quadratic

    local badnms "" // variable name not in model
    local isbad = 0
    local newvarnms ""
    foreach Vnm in `varnms' {
        local ipos : list posof "`Vnm'" in betainfonms
        if `ipos'==0 { // not in list of beta names
            local badnms "`badnms'`Vnm' "
            local isbad = `isbad' + 1
            * add 1. to name and check again
            local tmpnm "1.`Vnm'"
            local ipos : list posof "`tmpnm'" in betainfonms  // 0823
            if `ipos'!=0 {
                local isbad = `isbad' - 1 // var found, not an error
                local Vnm "`tmpnm'"
            }
            * did not find 1.var, check 2.
            else {
                local tmpnm "2.`Vnm'"
                local ipos : list posof "`tmpnm'" in betainfonms
                if `ipos'!=0 {
                    local isbad = `isbad' - 1 // var found, not an error
                    local Vnm "`tmpnm'"
                }
                else { // try 3.
                    local tmpnm "3.`Vnm'"
                    local ipos : list posof "`tmpnm'" in betainfonms
                    if `ipos'!=0 {
                        local isbad = `isbad' - 1 // var found, not an error
                        local Vnm "`tmpnm'"
                    }
                }
            }
        } // in list names in e(b)
        local newvarnms "`newvarnms'`Vnm' "
    } // foreach Vnm
    local varnms "`newvarnms'"
    local varnms : list uniq varnms

    if `isbad'==1 {
        display as error "variable `badnms' is not in model"
        exit
    }

    * types of regressors that determine how changes are computed
    local nms_bin "" // i.binvar names
    local nms_PW "" // i.catvar names, use margins, pwcompare
    local nms_interact "" // a#b
    local nms_dropint "" // drop a#b if a!=b
    local nms_quadcore "" // a#a type
    local nms_quadbeta "" // a#a e(b)'s
    foreach Vnm in `varnms' {
        local nm : subinstr local Vnm "." "_", all
        local nm : subinstr local nm "#" "_", all
        local isbin_`nm' = 0 // i.binvar
        local isPW_`nm' = 0 // i.catvar using pwcompare
        local isinteract_`nm' = 0 // any a#b
        local isdropint_`nm' = 0 // a#b where a!=b
        local isquad_`nm' = 0 // a#b where a==b and never a!=b (quadratic)
        local ipos : list posof "`Vnm'" in betainfonms
        if `ipos'>0 {
            * i.binary
            local isbin_beta = `betainfo'[1,`ipos']
            if `isbin_beta'==1 {
                local isbin_`nm' = 1
                local nms_bin "`nms_bin'`Vnm' "
            }
            * i.catvar
            local isPW_beta = `betainfo'[2,`ipos']
            if `isPW_beta'==1 {
                local isPW_`nm' = 1
                _ms_parse_parts `Vnm'
                local nms_PW "`nms_PW'`r(name)' "
            }
            * any interaction
            local isinteract_beta = `betainfo'[7,`ipos']
            if `isinteract_beta'==1 {
                local isinteract_`nm' = 1
                _ms_parse_parts `Vnm'
                local nms_interact "`nms_interact'`r(name)' "
            }
            * quadratic
            local isquad_beta = `betainfo'[9,`ipos']
            if `isquad_beta'==1 {
                local isquad_`nm' = 1
                _ms_parse_parts `Vnm'
                local nms_quadcore "`nms_quadcore'`r(name)' `r(name1)'"
                local nms_quadbeta "`nms_quadbeta'`Vnm' "
            }
            * interaction other than quadratic; drop this later
            local isdropint_beta = `betainfo'[10,`ipos']
            if `isdropint_beta'==1 {
                local isdropint_`nm' = 1
                _ms_parse_parts `Vnm'
                local nms_dropint "`nms_dropint'`r(name)' "
            }
        }
        local nms_quadcore : list uniq nms_quadcore
    } // var loop

    if "`nms_dropint'"!="" {
        local NOTEdropint ///
            "These variables not included because of interactions:"
        local NOTEdropint2 "  : `nms_dropint'"
    }

//  refine varnms for later processing

    local vars_main "" // standard processing
    local betas_PW "" // betas for pwcompare
    local vars_PW  "" // process with margins, pwcompare
    local vars_drop "" // not processed by mchange
    local vars_quad "" // quad terms where only src var kept
    local vars_quadsrc "" // source vars for quad terms
    foreach Vnm in `varnms' { // these names from e(b) columns
        local nm : subinstr local Vnm "." "_", all
        local nm : subinstr local nm "#" "_", all
        * is it i.catvar?
        if `isPW_`nm'' == 1 {
            local betas_PW "`betas_PW'`Vnm' "
            _ms_parse_parts `Vnm'
            local vars_PW "`vars_PW'`r(name)' "
        }
        * is it #quadratic
        else if `isquad_`nm'' == 1 {
            _ms_parse_parts `Vnm'
            * keep only source variable, not interactions
            local vars_main "`vars_main'`r(name1)' "
            local vars_quadsrc "`vars_quadsrc'`r(name1)' "
            local vars_quad "`vars_quad'`Vnm' "
        }
        * other interaction types are dropped
        else if (`isdropint_`nm''==1) local vars_drop "`vars_drop'`Vnm' "
        else local vars_main "`vars_main'`Vnm' "
    }
    local vars_main : list uniq vars_main
    local vars_quadsrc : list uniq vars_quadsrc
    local vars_PW : list uniq vars_PW
    if "`vars_quadsrc'"!="" {
        local n = wordcount("`vars_quadsrc'")
        if `n'==1 {
            local NOTEquad ///
                "Variable `vars_quadsrc' has quadratic terms in model."
        }
        else {
            local NOTEquad ///
                "Variables `vars_quadsrc' have quadratic terms in model."
        }
    }
    if ("`vars_main'"!="") local is_mainvars = 1
    else local is_mainvars = 0
    local vars_quad : list uniq vars_quad // 0.9.7

/*
di "vars_main: `vars_main'"
di "vars_PW : `vars_PW'"
di "betas_PW: `betas_PW'"
di "vars_drop: `vars_drop'"
di "vars_quad: `vars_quad'"
*/

//  assign locations in output and matrix & determine binary regressors

    local ivar = 0
    local iprtrow = 0
    foreach Vnm in `vars_main' { // main variables get standard processing
        local ++ivar
        local nm : subinstr local Vnm "." "_", all
        local nm : subinstr local nm "#" "_", all

        * use entire sample to determine if binary
        capture assert `Vnm'==0 | `Vnm'==1 | `Vnm'==.
        local isbin_`nm' = (_rc==0) // is a binary regressor

        * start location for each type of change
        local varstart = (`ivar'-1)*5 // 5 types of changes
        foreach Cnm in `Cset_all' {
            *     row_<Cnm>_<var> : output row# for Cnm+var pair
            local row_`Cnm'_`nm' = `varstart' + `offset_`Cnm''
        }
        foreach Cnm in `Cset_all' {
            * locations for binary variables
            if `isbin_`nm''==1 {
                local ipos : list posof "`Cnm'" in Cprt_bin
                if `ipos'>0 {
                    local ++iprtrow
                    * prt_<Cnm>_<var> : print row# for Cnm+var pair
                    local prt_`Cnm'_`nm' = `iprtrow'
                }
                else local prt_`Cnm'_`nm' = 0
            }
            * locations for continuous variales
            else {
                local ipos : list posof "`Cnm'" in Cprt_con
                if `ipos'>0 {
                    local ++iprtrow
                    local prt_`Cnm'_`nm' = `iprtrow'
                }
                else local prt_`Cnm'_`nm' = 0
            }
        } // Cnm loop
    } // var loop
    local maxprintrow = `iprtrow'

//  statistics type information

    * labels for output
    local Slbl_change "Change"
    local Slbl_ul "UL"
    local Slbl_ll "LL"
    local Slbl_z "z-value"
    local Slbl_se `"Std. Err."'
    local Slbl_pvalue "P>|z|"
    local Slbl_start "From"
    local Slbl_end "To"

    * sets of stats
    local S_nostrtend "change pvalue ul ll z se"
    local S_default "change pvalue"
    local S_show "`statistics'"
    if ("`S_show'"=="") local S_show "`S_default'"
    if ("`S_show'"=="all") local S_show "`S_all'"
    local ipos : list posof "ul" in S_show
    local S_isul = `ipos'>0
    local ipos : list posof "ll" in S_show
    local S_isll = `ipos'>0

//  matrices holding results for non-PW variables

    matrix `blank1var' = J(5,`lhsncats',.z) // 5 amounts X # of categories
    matrix rownames `blank1var' = `Crownms'  // row is change amount
    matrix colnames `blank1var' = `lhscatnms' // column is outcome
    matrix `blank1varR' = `blank1var'
    matrix rownames `blank1varR' = `CrownmsR'

    * stack matrices for each non-PW variables
    local isvars_main = 1
    if ("`vars_main'"=="") local isvars_main = 0 // no non-PW variables
    foreach Vnm in `vars_main' {
        local nm : subinstr local Vnm "." "_", all
        local nm : subinstr local nm "#" "_", all
        if `trim'!=0 & `isbin_`nm''!=1 { // trim and not binary variable
            local trimUB = 100 - `trim'
            qui centile `Vnm' `if' `in', centile(`trim' `trimUB')
            local rng_F = r(c_1)
            local rng_T = r(c_2)
            if "`rng_F'"=="`rng_T'" { // if trim range is 0, use range
                matrix roweq `blank1varR' = `Vnm'
                matrix `blankallvars' = nullmat(`blankallvars') \ `blank1varR'
            }
            else {
                matrix roweq `blank1var' = `Vnm'
                matrix `blankallvars' = nullmat(`blankallvars') \ `blank1var'
            }
        } // trim
        else { // not trimmed
            matrix roweq `blank1var' = `Vnm'
            matrix `blankallvars' = nullmat(`blankallvars') \ `blank1var'
        }
    }

    if `is_mainvars' { // non PW variables
        foreach Snm in `S_all' {
            matrix `_all_`Snm'' = `blankallvars'
            matrix coleq `_all_`Snm'' = `Snm'
        }
    }

//  run dummy margins to get labels for output


    qui {
        sum `e(depvar)'
        capture predict `predvar', outcome(`r(min)')
        capture drop `predvar'
        if _rc == 0 {
            local MarginPred "predict(outcome(`r(min)'))"
        }
        margins `if' `in', at(`at') `atmeans' `options' `MarginPred'
        local lvlis = r(level)
        local NOTEci "CI computed at `lvlis' percent level."
        matrix ATmat = r(at) // 099
        local ATnms : colnames ATmat
        local ATstatnms "`r(atstats1)'"

        _rm_marginsnames // names used by margins for predictions
        local Mtitle `s(title)'
        local Mpredict `s(predict)' // use with predict for ADC in stata 11
        local Mtype `s(type)'
        local Mmath `s(math)'
        local Mmath_noequal `s(math_noequal)'
        local Mmath10 `s(math10)'
        local Mlength `s(length)'

        * get name of prediction from count model; say predict(pr(0))
        if `mdlCRM' {
            local predlabel "`r(predict_label)'"
            if "`predlabel'"=="Predicted number of events" {
                local lhscatnms "Rate"
            }
            else local lhscatnms "`predlabel'"
        }
        local nobsifin = r(N)
        local p1base = el(r(b),1,1) // used for base predictions
    }

// base predictions 099

    capture drop matrix `pbase'
    local basecatnames "" // later print cat names with predictions
    if ("`atmeans'"=="atmeans") local baseheader "Predictions at base values"
    else local baseheader "Average predictions"

    if `mdlBRM' {
        local p0base = 1 - `p1base'
        matrix `pbase' = `p0base', `p1base'
        matrix rownames `pbase' = `""Pr(y|base)""'
        matrix colnames `pbase' = `lhscatnms'
    }
    else if `mdlCRM' {
        if ("`atmeans'"=="atmeans") ///
            local baseheader "Prediction at base values"
        else local baseheader "Average prediction"
        matrix `pbase' = `p1base'
        matrix rownames `pbase' = `""Rate""'
        local basecatnames "nonames"
    }
    else {
        foreach Oval in `lhscatvals' { // outcome value
            qui margins `if' `in', at(`at') `atmeans' `options' ///
                predict(outcome(`Oval'))
            local pval = el(r(b),1,1)
            matrix `pbase' = nullmat(`pbase') , `pval'
        }
        matrix rownames `pbase' = `""Pr(y|base)""'
        matrix colnames `pbase' = `lhscatnms'
    }

//  place at values in matrix atmat

    qui {
        local is_atmatrix = 0
        capture matrix list r(at)
        if _rc==0 { // r(at) exists
            local nrowsat = rowsof(r(at))
            if `nrowsat'>1 {
                display as error ///
"mchange allows only one value in at(); e.g., at(male=(0 1)) is invalid"
                exit
            }
            quietly mlistat, saveconstant(atmat)
            local is_atmatrix = `s(isconstant)' // at matrix fixed values
            if `is_atmatrix'==1 {
                matrix rownames atmat = "at"
                matrix `_at' = atmat
                capture matrix drop atmat
            }
            local atmatcolnms : colnames `_at'
        }
    } // quietly

//  compute changes: F==from & T==to in discrete change

    if "`use_predict'"=="yes" { // stata 13+ uses at(x=gen())
        qui {
            preserve
            gen `varinsamp' = 1 `if' `in'
            lab var `varinsamp' "temp: selected observation"
            gen `origvar' = .
            label var `origvar' "temp: before manipulation for AME"
            gen `varsd_DC' = .
            lab var `varsd_DC' "temp: sd DC"
            gen `varsd_F' = .
            lab var `varsd_F' "temp: sd from"
            gen `varsd_T' = .
            lab var `varsd_T' "temp: sd to"
            gen `varone_DC' = .
            lab var `varone_DC' "temp: one DC"
            gen `varone_F' = .
            lab var `varone_F' "temp: one from"
            gen `varone_T' = .
            lab var `varone_T' "temp: one to"
        }
    }

    matrix `vec_desc' = J(4,1,-9999) // desc for at variables
    matrix rownames `vec_desc' = Mean Std_Dev Min Max
    local ismat_desc = 0 // is mat_desc populated?

// loop over non PW variables and compute changes

    qui {
    local varnum = 0
    foreach Vnm in `vars_main' {
        local ++varnum

        * remove Vnm from atspec 099
        local ATspec "`ATinput'" // ATspec is changed for current Vnm
        local ipos : list posof "`Vnm'" in ATnms
        local ATval = ATmat[1,`ipos']
        if !missing(`ATval') {
            local ATisset = 1
            * remove Vnm from atspec
            local vequal "`Vnm'=`ATval'"
            local ipos : list posof "`vequal'" in ATspec
            local ATspec : subinstr local ATspec "`vequal'" "", all
            * remove name if entered with factor syntax
            local Vnm_nofv = regexr("`Vnm'","[0-9ic]+\."," ")
            local vequal "`Vnm_nofv'=`ATval'"
            local ipos : list posof "`vequal'" in ATspec
            local ATspec : subinstr local ATspec "`vequal'" "", all
            * remove name if entered with #b.xx=0 factor syntax
            local ATvalminus = 1 - `ATval' // 0b.x has 1- value of 1.x
            local removethis "0b.`Vnm_nofv'=`ATvalminus'"
            local ATspec : subinstr local ATspec "`removethis'" "", all
            local removethis "0b.`Vnm_nofv'=0"
            local ATspec : subinstr local ATspec "`removethis'" "", all
            local removethis "0b.`Vnm_nofv'=1"
            local ATspec : subinstr local ATspec "`removethis'" "", all
        }
        else {
            local ATisset = 0
            * and keep original ATspec
        }
*noi di "ATinput:  `ATinput'"
*noi di "ATspec:   `ATspec'"
        if "`use_predict'"=="yes" {
            replace `origvar' = `Vnm' // orig var before counterfactual
        }

        * variable name w/o factor variable symbols
        local nm : subinstr local Vnm "." "_", all
        local nm : subinstr local nm "#" "_", all

        * get non-fv name and check if 1. variable; remove i. too
        local Vnm_nofv = regexr("`Vnm'","[0-9i]+\."," ")
        local isfvbin = `isbin_`nm''

        * get from value & to value
        sum `Vnm' `if' `in'
        local mn = r(mean)
        local varmax = r(max)
        local varmin = r(min)
        local sd = r(sd)
        local sd2 = r(sd)/2
        if `delta' !=0 {
            local sd2 = `delta'/2
            local sd = `delta'
        }

        matrix `vec_desc'[1,1] = r(mean)
        matrix `vec_desc'[2,1] = r(sd)
        matrix `vec_desc'[3,1] = r(min)
        matrix `vec_desc'[4,1] = r(max)
        matrix colnames `vec_desc' = `Vnm'
        matrix `mat_desc' = nullmat(`mat_desc') , `vec_desc'
        local ismat_desc = 1

        local error = 0
        if `trim'==0 {
            local rng_F = r(min)
            local rng_T = r(max)
        }
        else { // trimned range
            if `is_svy' { // svy estimation
                display as error ///
                    "trim() cannot be used with svy estimation"
                local error = 1
                continue, break
            }
            if `isbin_`nm''==1 { // binary regressor range is 0 to 1
                local rng_F = 0
                local rng_T = 1
            }
            else { // not binary compute centiles
                local trimUB = 100 - `trim'
                centile `Vnm' `if' `in', centile(`trim' `trimUB')
                local rng_F = r(c_1)
                local rng_T = r(c_2)
                if "`rng_F'"=="`rng_T'" {
                    local rng_F = `varmin'
                    local rng_T = `varmax'
                    noisily display ///
                 "trimmed range for `Vnm' is 0; range of min to max is used"
                }
            }
        } // trim

        * svy estimation
        *   TODO: svy can't compute SD for fv's
        *   TODO: if can't compute SD, go to next variable, don't quit.
        *         perhaps try to compute other ways.
        *         see StataCorp Isabel Canette's comments
        if `is_svy' {
            capture svy : mean  `Vnm' `if' `in'
            if _rc!= 0 {
                display as error ///
                "cannot compute std dev for factor variables with svy data"
                exit
                continue
            }
            estat sd
            local mn = el(r(mean),1,1)
            local sd = el(r(sd),1,1)
            local sd2 = el(r(sd),1,1)/2
        }

        * at-value for current variable
        local atval = .
        capture matrix list `_at'
        if _rc==0 { // r(at) exists
            local icol : list posof "`Vnm'" in atmatcolnms
            local atval = `_at'[1,`icol']
        }
        if (`atval'==.) local baseval = `mn' // mean if not in r(at)
        else local baseval = `atval' // at value if specfied

        //  determine F_rom values and T_o values for changes

        * binary
        local bin_F = 0
        local bin_T = 1

        * one and sd
        if "`uncentered'"=="" { // centered
            * if base value give, use specific values
            local one_F = `baseval' - .5
            local one_T = `baseval' + .5
            local sd_F = `baseval' - `sd2'
            local sd_T = `baseval' + `sd2'
            * average DC use at(x=gen())

            if `ATisset' == 0 { // no at() for this variable 099
                local one_Fgen "`Vnm'=gen(`Vnm' - .5)"
                local one_Tgen "`Vnm'=gen(`Vnm' + .5)"
                local sd_Fgen "`Vnm'=gen(`Vnm' - `sd2')"
                local sd_Tgen "`Vnm'=gen(`Vnm' + `sd2')"
            }
            else { // if var is set with at, use the base value
                local one_Fgen "`Vnm'=gen(`ATval' - .5)"
                local one_Tgen "`Vnm'=gen(`ATval' + .5)"
                local sd_Fgen "`Vnm'=gen(`ATval' - `sd2')"
                local sd_Tgen "`Vnm'=gen(`ATval' + `sd2')"
            }
        }
        else { // uncentered
            local one_F = `baseval'
            local one_T = `baseval' + 1
            local sd_F = `baseval'
            local sd_T = `baseval' + `sd'
            if `ATisset' == 0 { // no at() for this variable
                local one_Fgen "`Vnm'=gen(`Vnm')"
                local one_Tgen "`Vnm'=gen(`Vnm' + 1)"
                local sd_Fgen "`Vnm'=gen(`Vnm')"
                local sd_Tgen "`Vnm'=gen(`Vnm' + `sd')"
            }
            else { // if var is set with at, use the base value
                local one_Fgen "`Vnm'=gen(`ATval')"
                local one_Tgen "`Vnm'=gen(`ATval' + 1)"
                local sd_Fgen "`Vnm'=gen(`ATval')"
                local sd_Tgen "`Vnm'=gen(`ATval' + `sd')"
            }
        }

        foreach Cnm in `Cset_dc' { // from to in one string
            local at_`Cnm' "``Cnm'_F' ``Cnm'_T'"
        }

        //  loop over categories and compute margins

        local Ocol = 0 // outcome column
        foreach Oval in `lhscatvals' { // outcome value

            local optpredict "" // default predict option for margins
            if (`mdlBRM') local Ocol = 2 // col for BRM
            else if (`mdlCRM') local Ocol = 1 // col for CRM mu
            else { // outcome # ut_val in col Ocol
                local ++Ocol
                local optpredict "predict(outcome(`Oval'))"
            }

            //  loop through change amounts and not partial

            foreach Cnm in `Cset_all' {

                *    print this change   &   change not marg
                if (`prt_`Cnm'_`nm''>0) & ("`Cnm'"!="marg") {

                estimates restore _mchange_model

                * at() list w/o factor variables
                local atFromTo "`Vnm_nofv'=(`at_`Cnm'')"

                * method for computing discrete change
                if "`Cnm'"=="bin" | "`Cnm'"=="rng" {
                    local do_fromto        "yes"
                    local do_atgen         "no" // at(x=gen(x+delta))
                    local do_predict       "no"
                    local do_marginsallobs "no"
                }
                else if "`Cnm'"=="one" | "`Cnm'"=="sd" {
                    if "`atmeans'"=="atmeans" {
                        local do_fromto "yes"
                    }
                    else if "`atmeans'"=="" {
                        * stata 13+
                        if c(stata_version)>=13 ///
                            & (_caller()>=13 | "`allow12'"=="") {
                            local do_atgen         "yes"
                            local do_fromto        "no"
                            local do_predict       "no"
                            local do_marginsallobs "no"
                        }
                        * stata pre 13 or version pre 13
                        else {
                            local do_fromto        "no"
                            local do_atgen         "no"
                            local do_predict       "no"
                            local do_marginsallobs "no"
                            if "`at'" != "" { // can't use predict
                                local do_marginsallobs "yes"
                            }
                            else local do_predict "yes"
                        }
                    } // not atmeans
                } // one | sd

                * missing when some can't be computed
                scalar `start' = .
                scalar `end' = .
                scalar `change' = .
                scalar `se' = .
                scalar `z' = .
                scalar `pvalue' = .
                scalar `ll' = .
                scalar `ul' = .
                scalar `lvl' = .

                * DC margins at(from to)
                if "`do_fromto'"=="yes" {

                  local mcmd "margins `if' `in', at(`atFromTo' `ATspec')" ///
                      " `atmeans' `options' post `optpredict'"
                  local mcmd : subinstr local mcmd "  " " ", all
                  local mcmd : subinstr local mcmd " ," ",", all
                  local mcmd : subinstr local mcmd "margins," "margins", all
                  `quicmd' di _new "Command for `Vnm': `mcmd'"
                  `qui' margins `if' `in', at(`atFromTo' `ATspec') ///
                      `atmeans' `options' post `optpredict'
                  local neb = colsof(r(b))
                  if `neb'!=2 { // 0910
                    display in red ///
                    "fatal error decode at() specification for `Vnm':"
                    display in red "     at(`atFromTo' `ATspec') `atmeans'"
                    display in red
                    exit
                  }
                  `quicmd' di _new "Command: lincom _b[2._at] - _b[1._at]"
                  `qui' lincom _b[2._at] - _b[1._at]
                  _rm_lincom_stats
                  scalar `start'  = _b[1._at]
                  scalar `end'    = _b[2._at]
                  scalar `change' = r(est)
                  scalar `se'     = r(se)
                  scalar `z'      = r(z)
                  scalar `pvalue' = r(p)
                  scalar `ll'     = r(lb)
                  scalar `ul'     = r(ub)
                  scalar `lvl'    = r(level)
                  estimates restore _mchange_model
                } // margins at(from to)

                * DC margins at(x=gen(x+1))
                else if "`do_atgen'"=="yes" {

                  local atFgen "``Cnm'_Fgen'"
                  local atTgen "``Cnm'_Tgen'"
                  local mcmd "margins `if' `in'," ///
                      " at(`atFgen' `ATspec') at(`atTgen' `ATspec')" ///
                      " `atmeans' `options' post `optpredict'"
                  local mcmd : subinstr local mcmd "  " " ", all
                  local mcmd : subinstr local mcmd " ," ",", all
                  local mcmd : subinstr local mcmd "margins," "margins", all
                  `quicmd' di _new "Command for `Vnm': `mcmd'"
                  `qui' margins `if' `in', ///
                      at(`atFgen' `ATspec') at(`atTgen' `ATspec') ///
                      `atmeans' `options' post `optpredict'
                  local neb = colsof(r(b))
                  if `neb'!=2 { // 0910
                    display in red ///
                    "fatal error decode at() specification for `Vnm':"
                    display in red "     at(`atFromTo' `ATspec') `atmeans'"
                    display in red
                    exit
                  }
                  `quicmd' di "Command: lincom _b[2._at] - _b[1._at]"
                  `qui' lincom _b[2._at] - _b[1._at]
                  _rm_lincom_stats
                  scalar `start'  = _b[1._at]
                  scalar `end'    = _b[2._at]
                  scalar `change' = r(est)
                  scalar `se'     = r(se)
                  scalar `z'      = r(z)
                  scalar `pvalue' = r(p)
                  scalar `ll'     = r(lb)
                  scalar `ul'     = r(ub)
                  scalar `lvl'    = r(level)
                  estimates restore _mchange_model
                } // margins at(x=gen())

                * DC predict
                else if "`do_predict'"=="yes" {

                  if ("`lhscatvals'"=="1") local predictout ""
                  else local predictout "outcome(`Oval')"
                  if "`uncentered'"=="" {
                      if "`Cnm'"=="one" {
                          local subtractthis = .5
                          local addthis = .5
                      }
                      if "`Cnm'"=="sd" {
                          local subtractthis = `sd2'
                          local addthis = `sd2'
                      }
                  }
                  if "`uncentered'"!="" {
                      local subtractthis = 0
                      if ("`Cnm'"=="one") local addthis = 1
                      if ("`Cnm'"=="sd")  local addthis = `sd'
                  }
                  * replace observed with counterfactual and predict
                  replace `Vnm' = `origvar' - `subtractthis'
                  capture drop `predictF'
                  local predictout2 : subinstr local predictout ///
                      "outcome(" "outcome(#", all
                  if ("`Mpredict'"=="`predictout'") local Mpredict ""
                  local mcmd "predict `predictF' if `varinsamp'==1," ///
                      " `predictout2' `Mpredict'"
                  local mcmd : subinstr local mcmd "  " " ", all
                  local mcmd : subinstr local mcmd " ," ",", all
                  `quicmd' di _new "Command for `Vnm': `mcmd'"
                  predict `predictF' if `varinsamp'==1, ///
                      `predictout2' `Mpredict'
                  replace `Vnm' = `origvar' + `addthis'
                  capture drop `predictT'
                  predict `predictT' if `varinsamp'==1, ///
                      `predictout2' `Mpredict'
                  `quicmd' di _new "Command for `Vnm': predict `predictT'" ///
                      " if `varinsamp'==1, `predictout2' `Mpredict'"
                  capture drop `predictDC'
                  gen `predictDC' = `predictT' - `predictF'
                  sum `predictDC' if `varinsamp'==1
                  scalar `change' = r(mean)
                  replace `Vnm' = `origvar' // restore original data

                } // AME 1 & SD using predict

                * DC looping over margins for all observations
                *   Can be sped up by using counterfactual predictions.
                *   All atvars must be changed. jsl 2013-07-03
                else if "`do_marginsallobs'"=="yes" {
                  if "`isatslow'"=="" {
                      local isatslow = 1
                      noi display "AME with at() for 1 or SD change" ///
                          " is slow prior to Stata 13"
                  }
                  else {
                      noi display "Computations are proceeding normally..."
                  }
                  forvalues iobs = 1(1)`nobs' {
                      local isin = `varinsamp'[`iobs']
                      if `isin'==1 {
                          local varis = `Vnm'[`iobs']
                          if "`uncentered'"=="" {
                              local one_F = `varis' - .5
                              local one_T = `varis' + .5
                              local sd_F  = `varis' - `sd2'
                              local sd_T  = `varis' + `sd2'
                          }
                          else { // uncentered
                              local one_F = `varis'
                              local one_T = `varis' + 1
                              local sd_F  = `varis'
                              local sd_T  = `varis' + `sd'
                          }
                          local atFromTo ///
                              "`Vnm_nofv'=(``Cnm'_F' ``Cnm'_T')"
                          * margins is slow but allows at() & other options
                          `qui' margins in `iobs', at(`atFromTo' `ATspec') ///
                              `atmeans' `options' `optpredict' nose
                          scalar `start' = el(r(b),1,1)
                          scalar `end' = el(r(b),1,2)
                          scalar `change' = `end' - `start'
                          qui replace `var`Cnm'_F' = `start' in `iobs'
                          qui replace `var`Cnm'_T' = `end' in `iobs'
                          qui replace `var`Cnm'_DC' = `change' in `iobs'
                      } // in sample
                  } // obs loop
                  qui sum `var`Cnm'_DC'
                  scalar `change' = r(mean)
                } // AME sd & one with at()

                * DC not computed
                else {
                  * all are now computed
                }

                foreach Snm in `S_all' {
                    matrix `_all_`Snm''[`row_`Cnm'_`nm'',`Ocol'] = ``Snm''
                }

            } // if print and not marg

          } // Cnm

        //  partial

        if `prt_marg_`nm''>0 {
            estimates restore _mchange_model
            * remove i. 1. from fv's
            local Vnm_nofv = regexr("`Vnm'","[0-9i]+\."," ")
            local mcmd "margins `if' `in', dydx(`Vnm_nofv') at(`ATspec')" ///
                " `atmeans' post `options' `optpredict'"
            local mcmd : subinstr local mcmd "  " " ", all
            local mcmd : subinstr local mcmd " ," ",", all
            local mcmd : subinstr local mcmd "margins," "margins", all
            `quicmd' di _new "Command for `Vnm': `mcmd'"
            `qui' margins `if' `in', dydx(`Vnm_nofv') ///
                at(`ATspec') `atmeans' post `options' `optpredict'
            scalar `change' = el(r(table),1,1)
            scalar `se'     = el(r(table),2,1)
            scalar `z'      = el(r(table),3,1)
            scalar `pvalue' = el(r(table),4,1)
            scalar `ll'     = el(r(table),5,1)
            scalar `ul'     = el(r(table),6,1)
            scalar `start'  = .
            scalar `end'    = .
            scalar `lvl'    = r(level)
            foreach Snm in `S_all' {
                matrix `_all_`Snm''[`row_marg_`nm'',`Ocol'] = ``Snm''
            }
            estimates restore _mchange_model
        } // if partial

      } // loop over Oval

    } // loop over Vnm

    } // quietly

    if (`error'==1) exit

//  bystat: matrices with results for each statistics for non-PW vars

    foreach Snm in `S_all' {
        foreach Vnm in `vars_main' { // non PW variables

            local nm : subinstr local Vnm "." "_", all
            local nm : subinstr local nm "#" "_", all

            if (`isbin_`nm''==1) local Cprt_list `Cprt_bin'
            else  local Cprt_list `Cprt_con'

            foreach Cnm in `Cprt_list' { // select changes being printed
                if `prt_`Cnm'_`nm''>0 {
                    matrix `_prt_`Snm'' = nullmat(`_prt_`Snm'') ///
                        \ `_all_`Snm''[`row_`Cnm'_`nm'',1...]
                }
            }
        } // Vnm
    } // Snm

* 2013-08-01 does not work if only # var

    * `_prt' combines all stats by column for binary
    if `mdlBRM' & `is_mainvars' {
        foreach Snm in `S_show' {
            matrix coleq `_prt_`Snm'' = ""
            matrix coln `_prt_`Snm'' = `""`Slbl_`Snm''""'
            * col 2 has pr(1); col 1 has pr(0)
            matrix `_prt' = nullmat(`_prt') , `_prt_`Snm''[1...,2]
        }
    }

//  byvar: matrices with results in order of variables

    capture matrix drop `_byvar'
    if `mdlBRM' & `is_mainvars' { // BRM us _prt for nonPW vars
        matrix `_byvar' = `_prt'
    }
    else if `is_mainvars' { // non-binary and non PW vars

        foreach Vnm in `vars_main' {

            local nm : subinstr local Vnm "." "_", all
            local nm : subinstr local nm "#" "_", all
            local Clist `Cprt_con' `Cprt_bin'
            local Clist : list uniq Clist

            foreach Cnm in `Clist' {
                local clblnm "`Clbl_`Cnm''"
                foreach Snm in `S_show' {
                    if `prt_`Cnm'_`nm''>0 {
                        * grab change row, all columns
                        matrix `vecis' = ///
                            `_all_`Snm''[`row_`Cnm'_`nm'',1...]
                        local rowfullnm : rowfullnames `vecis'
                        local roweqnm : roweq `vecis'
                        if "`Snm'"=="change" {
                            local rowfullnm "`roweqnm':`clblnm'"
                        }
                        else local rowfullnm "`roweqnm':`Snm'"
                        matrix rownames `vecis' = "`rowfullnm'"
                        matrix `_byvar' = nullmat(`_byvar') \ `vecis'
                    }
                } // Snm
            } // Cnm
        } // Vnm
        matrix coleq `_byvar' = ""
    }

//  process PW vars

    * location of stats in r(table) & r(table_vs)
    local tabloc_change = 1
    local tabloc_se = 2
    local tabloc_z = 3
    local tabloc_pvalue = 4
    local tabloc_ll = 5
    local tabloc_ul = 6
    local tabloc_startindx = 7
    local tabloc_endindx = 8
    local tabloc_start = 9
    local tabloc_end = 10

    qui {
    local varnum = 0
    foreach VnmPW in `vars_PW' {
        local ++varnum

        local makepltmat = 1 // create matrix to hold plot values
        local Ocol = 0
        foreach Oval in `lhscatvals' { // outcome categories

            local optpredict ""
            if (`mdlBRM') local Ocol = 2 // pr(1) in col 2
            else if (`mdlCRM') local Ocol = 1 // mu is col 1
            else {
                local ++Ocol
                local optpredict "predict(outcome(`Oval'))"
            }

            * run margins, pwcompare
            local mcmd "margins `VnmPW' `if' `in'," ///
                " pwcompare at(`ATspec') `atmeans' `options' `optpredict'"
            local mcmd : subinstr local mcmd "  " " ", all
            local mcmd : subinstr local mcmd " ," ",", all
            local mcmd : subinstr local mcmd "margins," "margins", all
            `quicmd' di _new "Command for `Vnm': `mcmd'"
            `qui' margins `VnmPW'  `if' `in', pwcompare ///
                at(`ATspec') `atmeans' `options' `optpredict'

            * _allPW_(variablename)_(outcome #) == contrasts
            *   row is statisitic; col is contrast
            matrix       _allPW_`VnmPW'_`Oval' = r(table_vs)'
            matrix roweq _allPW_`VnmPW'_`Oval' = `VnmPW'
            local nPW_`VnmPW' = rowsof(_allPW_`VnmPW'_`Oval')
            local PWlabels_orig : colnames r(table_vs)
            * used to get names value labels for contrasts
            matrix `tempmat' = _allPW_`VnmPW'_`Oval'' // <- ' is intended

            * pr(y=j|x) to compute contrasts pr(y=j)-pr(y=k)
            matrix `_PWprobsrc' = r(table)'
            matrix `_PWprob' = J(`nPW_`VnmPW'',4,.)
            matrix colnames `_PWprob' = start end startpr endpr
            matrix rownames `_PWprob' = `PWlabels_orig'

            * loop through contrasts get names and start end info
            local contrastnms ""
            local PWlabels ""
            forvalues i = 1/`nPW_`VnmPW'' {

                * create contrast names using value labels
                _ms_element_info, element(`i') matrix(`tempmat') compare
                local label`i' `"`r(level)'"'
                local PWlabels "`PWlabels' "`r(level)'" "
                local labellen = length("`r(level)'")
                if (`labellen'>`twid') local twid = `labellen'

                * get prob being subtracted in PW contrast
                local tmplabel : word `i' of `PWlabels_orig'
                local tmplabel : subinstr local tmplabel ".`VnmPW'" "", all
                local tmplabel : subinstr local tmplabel "vs" " ", all
                local tmplabel : subinstr local tmplabel "bn" "", all
                local start : word 1 of `tmplabel' // start outcome in PW
                local end : word 2 of `tmplabel' // end outcome in PW
                matrix `_PWprob'[`i',1] = `start'
                matrix `_PWprob'[`i',2] = `end'
                matrix `_PWprob'[`i',3] = `_PWprobsrc'[`start',1] // start pr
                matrix `_PWprob'[`i',4] = `_PWprobsrc'[`end',1] // end pr

                * dummy matrices to hold pwcompare information for plotting
                if `makepltmat'==1 {
                    forvalues PWval = 1/`nPW_`VnmPW'' {
                        * v is PWvar number; c PW contrast number
                        matrix _PWdc_V`varnum'PW`PWval' = `blank1var'
                        matrix _PWpvalue_V`varnum'PW`PWval' ///
                            = _PWdc_V`varnum'PW`PWval'
                    }
                    local makepltmat = 0
                }

                * name variable with variable and contrast
                local nmPW "`start'vs`end'.`VnmPW'"
                matrix roweq _PWdc_V`varnum'PW`i' = `nmPW'
                matrix _PWdc_V`varnum'PW`i'[2,`Ocol'] ///
                            = _allPW_`VnmPW'_`Oval'[`i',`tabloc_change']
                matrix _PWpvalue_V`varnum'PW`i'[2,`Ocol'] ///
                            = _allPW_`VnmPW'_`Oval'[`i',`tabloc_pvalue']
            } // loop over contrasts

            * add info on start & end probabilities
            matrix _allPW_`VnmPW'_`Oval' ///
                = _allPW_`VnmPW'_`Oval'[1...,1..6], `_PWprob'
            matrix rownames _allPW_`VnmPW'_`Oval' = `PWlabels'

        } // loop over outcome categories
        local nOutcomes = `Ocol'

        * combine contrasts and values to single matrix
        capture matrix drop _prtPW
        foreach Snm in `S_all' {

            capture matrix drop _prtPW_`VnmPW'_`Snm'
            matrix `tempmat' = J(`nPW_`VnmPW'',`nOutcomes',.)
            matrix colnames `tempmat' = `lhscatnms'
            matrix rownames `tempmat' = `PWlabels'
            matrix roweq `tempmat' = `VnmPW'
            forvalues irow = 1/`nPW_`VnmPW'' {
                * note: for BRM results are put in column 1
                foreach jcol in `lhscatvals' {
                    scalar `temp' ///
                        = _allPW_`VnmPW'_`jcol'[`irow',`tabloc_`Snm'']
                    matrix `tempmat'[`irow',`jcol'] = `temp'
                }
            }
            matrix _prtPW_`VnmPW'_`Snm' ///
                = nullmat(_prtPW_`VnmPW'_`Snm') \ `tempmat'
        } // Snm

*? Check for CRM
        * only add columns if not BRM
        if `mdlBRM'!=1 {
            local nPWrows = rowsof(_prtPW_`VnmPW'_change)
            forvalues irow = 1/`nPWrows' {
                local notfirst = 0
                foreach Snm in `S_show' {
                    matrix `vecis' = _prtPW_`VnmPW'_`Snm'[`irow',1...]
                    local rowfullnm : rowfullnames `vecis'
                    local roweqnm : roweq `vecis'
                    if (`notfirst'==1) local rowfullnm "`roweqnm':`Snm'"
                    else {
                        local rowfullnm "`rowfullnm'"
                        local notfirst = 1
                    }
                    matrix rownames `vecis' = "`rowfullnm'"
                    matrix _prtPW = nullmat(_prtPW) \ `vecis'
                } // stat
            }
        } // not BRM

        * construct show matrix
        foreach Snm in `S_show' {
            if `mdlBRM' {
                tempname addstat
                matrix `addstat' = _allPW_`VnmPW'_1[1...,`tabloc_`Snm'']
                matrix colname `addstat'  = `""`Slbl_`Snm''""'
                matrix _prtPW = nullmat(_prtPW) , `addstat'
            }
            else { // not binary
                matrix `_prt_`Snm'' = nullmat(`_prt_`Snm'') ///
                    \ _prtPW_`VnmPW'_`Snm'
            } // not binary
        }

        matrix `_byvar' = nullmat(`_byvar') \ _prtPW

        if (`mdlBRM') matrix `_prt' = nullmat(`_prt') \ _prtPW

    } // PW variables

    } // qui for margins, pwcompare

//  print results

    local twid = `twid' + 1
    if ("`title'"=="") local titlenm "`mdlTITLE': Changes in `Mmath_noequal'"
    else local titlenm "`title'"
    display _new "{sf}`titlenm' | N = `nobsifin'" _continue

//  show results by statistic

    if `mdlBRM' {
        matlist `_prt', format(%`width'.`decimals'f) lines(oneline) ///
            title("{bf}`Slbl_`s''{sf}") underscore twidth(`twid')
    }
    else { // not binary
        if "`bystatistics'"=="bystatistics" {
            display
            foreach Snm in `S_show' {
                matrix coleq `_prt_`Snm'' = ""
                matlist `_prt_`Snm'', format(%`width'.`decimals'f) ///
                    twidth(`twid') title("{bf}`Slbl_`Snm''{sf}") ///
                    lines(oneline) underscore
            }
        } // by stat
        else {
            if (`mdlCRM') matrix colnames `_byvar' = `lhscatnms'
            matlist `_byvar', format(%`width'.`decimals'f) twidth(`twid') ///
               title("{bf}`Slbl_`s''{sf}") lines(oneline) underscore
        }
    }

//  base values

    if "`brief'"=="" {
        di _new "{sf}`baseheader'"
        matrix list `pbase', noheader format(%7.`decimals'f) `basecatnames'
    }

    if `is_atmatrix' & "`brief'"=="" {
        * remove b. columns from i. variables
        capture matrix drop `selmat'
        local colnms : colnames `_at'
        foreach icolnm of local colnms {
            local isbdot = 1 - regexm(`"`icolnm'"',"b\.")
            matrix `selmat' = nullmat(`selmat') , `isbdot'
        }
        _rm_matrix_select `_at' `selmat' col
        * remove missing columns
        _rm_matrix_nomiss `_at' col  // "`colnames'"
        display as text _new "{sf}Base values of regressors{sf}"
        matrix rownames `_at' = `"r(at)"'
        matrix list `_at', noheader format(%7.`decimals'f)
    }
    else local NOTEnocon "Predictions averaged over the sample."

    if ("`descriptives'"=="descriptives") & `ismat_desc'==1 {
        matlist `mat_desc', format(%7.4g) underscore border(none) ///
            lines(none) twidth(8) title(Descriptive statistics)
    }
    display

    if  "`brief'"=="" {
        local i = 1
        if "`atmeans'"=="atmeans" {
            display _col(1) "`i': Estimates with margins option atmeans."
            local ++i
        }
        if "`nms_dropint'"!="" {
            display _col(1) "`i': `NOTEdropint'"
            display _col(4) "`NOTEdropint2'"
            local ++i
        }
        if "`NOTEquad'"!="" {
            display _col(1) "`i': `NOTEquad'"
            local ++i
        }
        if "`NOTEnocon'"!="" {
            display _col(1) "`i': `NOTEnocon'"
            local ++i
        }
        if "`NOTEdelata'"!="" {
            display _col(1) "`i': `NOTEdelata'"
            local ++i
        }
        if "`NOTEsample'"!="" {
            display _col(1) "`i':`NOTEsample'"
            local ++i
        }
        if `C_isrng'==1 {
            display _col(1) "`i': `NOTEtrim'"
            local ++i
        }
        if `S_isul'==1 | `S_isll'==1 {
            display _col(1) "`i': `NOTEci'"
            local ++i
        }
    } // brief

//  matrices for orplot and dcplot

    if `is_mainvars' {
        matrix _mchange_plot_dc = `_all_change' // for orplot and dcplot
        matrix _mchange_plot_pvalue = `_all_pvalue' // for orplot & dcplot
    }

    capture matrix drop _mchange_plotPW_pvalue
    capture matrix drop _mchange_plotPW_dc
    local Vval = 0
    foreach VnmPW in `vars_PW' {
        local ++Vval
        forvalues i = 1/`nPW_`VnmPW'' {
            matrix _mchange_plotPW_dc ///
                = nullmat(_mchange_plotPW_dc) \ _PWdc_V`Vval'PW`i'
            matrix _mchange_plotPW_pvalue ///
                = nullmat(_mchange_plotPW_pvalue) \ _PWpvalue_V`Vval'PW`i'
            capture matrix drop _PWpvalue_V`Vval'PW`i'
            capture matrix drop _PWdc_V`Vval'PW`i'
        }
    }

//  cleanup

    qui estimates restore _mchange_model
    foreach VnmPW in `vars_PW' {
        foreach Oval in `lhscatvals' {
            capture matrix drop _allPW_`VnmPW'_`Oval'
        }
    }
    capture matrix drop _prtPW
    foreach VnmPW in `vars_PW' {
        foreach Snm in `S_all' {
            capture matrix drop _prtPW_`VnmPW'_`Snm'
            capture matrix drop _temp_PW`Snm'
        }
    }

//  returns

    return scalar N = `nobsifin'
    return matrix basepred `pbase'
    return matrix atmatrix ATmat
    capture matrix drop ATmat
    if `mdlBRM' {
        return matrix table = `_prt'
        if ("`matrix'"!="") matrix `matrix' = `_prt'
        if `is_mainvars' {
            foreach Snm in `S_all' {
                return matrix `Snm' = `_prt_`Snm''
            }
        }
    }

    if !`mdlBRM' & `is_mainvars' {
        foreach Snm in `S_all' {
            return matrix `Snm' = `_prt_`Snm''
        }
        return matrix table = `_byvar'
        if ("`matrix'"!="") matrix `matrix' = `_byvar'
    }
end

* decode amount
program define parse_amt, sclass
    local isbad = 1
    local amt "`1'"
    local is = inlist("`amt'","r","ra","ran","rang","range","rng")
    if `is'==1 {
        local amt "rng"
        local isbad = 0
    }
    local is = inlist("`amt'","b","bi","bin","bina","binar","binary")
    if `is'==1 {
        local amt "bin"
        local isbad = 0
    }
    local is = inlist("`amt'","1","o","on","one")
    if `is'==1 {
        local amt "one"
        local isbad = 0
    }
    local is = inlist("`amt'","s","sd")
    if `is'==1 {
        local amt "sd"
        local isbad = 0
    }
    local is = inlist("`amt'","m","ma","mar","marg","margi","margin")
    if `is'==1 {
        local amt "marg"
        local isbad = 0
    }
    else {
        local is = inlist("`amt'","margina","marginal","dydx","partial")
        if `is'==1 {
            local amt "marg"
            local isbad = 0
        }
    }
    sreturn local amount "`amt'"
    sreturn local isbad "`isbad'"
end

program define parse_stat, sclass
    local isbad = 1
    local stat "`1'"
    local is = inlist("`stat'","z","zv","zva","zval","zvalu","zvalue")
    if `is'==1 {
        local stat "z"
        local isbad = 0
    }
    local is = inlist("`stat'","t","tv","tva","tval","tvalu","tvalue")
    if `is'==1 {
        local stat "z"
        local isbad = 0
    }
    local is = inlist("`stat'","from")
    if `is'==1 {
        local stat "start"
        local isbad = 0
    }
    local is = inlist("`stat'","st","sta","star","start")
    if `is'==1 {
        local stat "start"
        local isbad = 0
    }
    local is = inlist("`stat'","to")
    if `is'==1 {
        local stat "end"
        local isbad = 0
    }
    local is = inlist("`stat'","en","end")
    if `is'==1 {
        local stat "end"
        local isbad = 0
    }
    local is = inlist("`stat'","change","first","dydx","estimat","estimate")
    if `is'==1 {
        local stat "change"
        local isbad = 0
    }
    local is = inlist("`stat'","dc","e","es","est","esti","estim","estima")
    if `is'==1 {
        local stat "change"
        local isbad = 0
    }
    local is = inlist("`stat'","upper","ub","ul")
    if `is'==1 {
        local stat "ul"
        local isbad = 0
    }
    local is = inlist("`stat'","lower","lb","ll")
    if `is'==1 {
        local stat "ll"
        local isbad = 0
    }
    local is = inlist("`stat'","p","pv","pva","pval","pvalu","pvalue")
    if `is'==1 {
        local stat "pvalue"
        local isbad = 0
    }
    local is = inlist("`stat'","se","s")
    if `is'==1 {
        local stat "se"
        local isbad = 0
    }
    sreturn local stat "`stat'"
    sreturn local isbad "`isbad'"

end
exit

MATRICES

_all_(stat) : row is Change; col is outcome        all variables; not PW
            : estimates are placed in here

_prt_(stat) : only those printed

_at'        : at values
_PWprob     : PW probabilities by category
_PWprobsrc  : source data for building _PWprob
_prt        : merge stats from _prt_stat

_byvar      : by vars to print

_allPW_(variablename)_(outcome #)   : contrasts for var for given outcopme

_PWdc_V#PW#           DC plot info by variable by PW
_PWpvalue_V#PW#       pvalue plot info

_prtPW_(variablename)_(stat)

_prtPW_     : combined informaiton to print

INSERTS see: mchange-fragments.ado

* 0.9.1 2013-07-03 | long freese | pass Mpredict to predict in stata <13
* 0.9.2 2013-07-06 | long freese | uses at(gen) in stata 13 even if version 12
* 0.9.3d 2013-07-09+11 | long freese | outcome() bug again removing Mpredict
* 0.9.3c 2013-07-09+11 | long freese | outcome() bug
* 0.9.3b 2013-07-09+11 | long freese | outcome() bug
* 0.9.4.1 | long freese | allow12 to allow stata12 version control in stata13; * fix +1 +SD bug
* 0.9.4 2013-07-12 | long freese | add pw labels - not fully tested
* 0.9.4.2 | long freese | sync returns for outcomes in Stata 12 and 13
* 0.9.11a 2013-08-07 | long freese | decimal
* 0.9.11 2013-08-07 | long freese | refine atspec
* 0.9.10 2013-08-07 | long freese | trap atspec decoding errors
* 0.9.9 2013-08-07 | long freese | allow atspec; base values
* 0.9.8 2013-08-01 | long freese | remove 0b. in varlist
* 0.9.7 2013-08-01 | long freese | varlist with a#b var included
* 0.9.6 2013-07-30 | long freese | multiple catvars
* 0.9.5 | long freese | stats() conform error for i.catvar; export pw info
* 0.9.11a 2013-08-07 | long freese | decimal
* TODO add pwcompare to dcplot; see saved matrices; need changes in dcplot
* TODO: compute sd if svy if survey variables
* TODO: generalize for any predict() as was done with count?
* TODO: average discrete change when categorical
* TODO: contrasts with only base category

/*
ADD TO DOC
DONE    COMMANDs /// list commands
DONE    r(basepred)
DONE    r(atmat)

ABBREVIATIONS
    C   change    Cnm: bin one sd marg rng
    S   stat      Snm: change ul ll z se pvalue start end
    V   var
    O   outcome
    PW  pwcompare
    M   margins
    F   from value
    T   to value
    _   matrix
    AT r(at) infor
*/
