*! mgen1.ado was mgen 0.8.9 2013-08-11 | freese long | fvValue problem
* version 0.8.9 2013-08-11 | freese long | fvValue problem
* version 0.8.7 2013-08-09 | freese long | replace; fix in if/in
* version 0.8.6 2013-08-09 | freese long | better output

//  generate variables from margins

/* TO DOCUMENT
*/

capture program drop mgen1
capture program drop _MGen
capture program drop _MarginsParse
capture program drop _GetModelType
capture program drop _GetVaryingAtList

program define mgen1, rclass

    version 11.2

// parse syntax of command

    syntax [name] [if] [in] , ///
  [ ///
        replace /// replace if variables exist
    /// what to display
        Details /// show margins
        CODEbook /// codebook of new variables
        /// BWidth(real 0) /// band width around at variable
        beta /// test options run only if beta
    /// what to generate
        ALLSTat ALLStats /// generate all stats pvalue, z, se, ll, ul
        noci /// no CI, only margin
        CONDitional /// conditional probabilities
        MEANPred /// generate values for plotting and transpose of predictions
        MEANPRe ///
        ATVAr(string asis) ATVars(string asis) /// select r(at) variables
        OUTcome(string asis) /// predict values for these outcomes    ///
        force /// for count on non-integer
    ///
        stub(string asis) /// stub used for names of variables
        VALUELength(numlist >0 integer) /// length of value label stub
        MLabel(string asis) /// label for naming margin
        PREDName(string asis) /// allow override of margin name
        PREDLabel(string asis) /// label for naming margin
        NOLabel /// whether to use value labels vs #s for categories
      * /// everything else will get passed along
    ]

//  if and in parsed

    local ifin "`if'`in'"
    if "`in'"!="" local in " `in'"
*    if "`if'"!="" { // remove if to add with e(sample) in later if's
*        local if : subinstr local if "if " "", all
*    }
    local ifin "`if'`in'" // 085
    return local ifin // 085
    local newvars ""

//  trap errors

    if "`e(cmd)'"=="ztnb" | "`e(cmd)'"=="ztp" {
        display as error "use tpoisson or tnbreg instead of ztp or ztnb"
        error 999
    }

//  process options

    if ("`nolabel'"=="") local UseLabels = "TRUE"
    else local UseLabels = "FALSE"

    local StubName = "_"
    if ("`stub'"!="") local StubName "`stub'"

    if ("`details'"=="details") local qui ""
    else local qui "quietly"

    * handle abbreviations problem with passthru
    if ("`atvar'"!="") local atvars = "`atvar'"
    if ("`meanpre'"!="") local meanpred = "meanpred"
    * use allstats later in program
    if ("`allstats'"!="" | "`allstat'"!="") local allstats "allstats"
    * allstats dominates noci
    if ("`allstats'"!="" & "`noci'"=="noci") local noci ""

    local OverValues "`outcome'" // empty if options not specified
    local newvarnms ""
    local ulName = "ul"
    local llName = "ll"

//  get model type

    _GetModelType , `force' `conditional'
    * either "outcome" (cats) "pr" (count) "p" (binary) or ""
    local ExprType "`s(expressiontype)'"

//  handle passthru of margins options

    _MarginsParse, `options'
    local MarginsOpts "`s(options)'" // macro used by margins command
    * either empty or TRUE if predict() specified
    local MarginsPredOpt "`s(predictused)'"
    * either empty or TRUE if expression() specified
    local MarginsExprOpt "`s(expressionused)'"
    * either empty or TRUE if at() specified
    local MarginsAtExpr "`s(atused)'"
    * either empty or TRUE if at() specified
    local MarginsAtmeansExpr "`s(atmeansused)'"
    * macro indicating whether an at matrix will be created
    local AtMatrixExists = "FALSE"
    if "`MarginsAtExpr'" != "" | "`MarginsAtmeansExpr'" != "" {
        local AtMatrixExists "TRUE"
    }
    local isover = strpos("`s(options)'","over(") // margins, over() used
    * require at, atmeans, or over() used
    if "`AtMatrixExists'"=="FALSE" & "`meanpred'"=="" & `isover'==0 {
        display as error ///
            "either at(), atmeans, or meanpred option must be specified"
        error 999
    }

    * is margins nose option used?
    local isnose = strpos("`MarginsOpts'","nose")>0
    * without SE these statistics can't be computed
    if `isnose'==1 {
        if "`noci'"=="" | "`allstats'"=="allstats" {
            di "With -nose- option, option -noci- is used."
        }
        local noci "noci"
        local allstats ""
    }

/*
* check options
di "MarginsOpts         : `MarginsOpts'"
di "MarginsPredOpt      : `MarginsPredOpt'"
di "MarginsExprOpt      : `MarginsExprOpt'"
di "MarginsAtExpr       : `MarginsAtExpr'"
di "MarginsAtmeansExpr  : `MarginsAtmeansExpr'"
di "AtMatrixExists      : `AtMatrixExists'"
di "isnose:             : `isnose'"
*/

//  create _MGen options

    local _MGenOpts "statoptions(`noci'`allstats') ulname(`ulName')"
    local _MGenOpts "`_MGenOpts' llname(`llName') mlabel(`predlabel')"

//  OverValues: what the loop is over for cat variables (empty otherwise)

    * default to all categories if predict(), expression(), and outcome()
    * not specified and model either categorical or binary
     if "`ExprType'" == "outcome" { // only for cat and binary models
         if "`OverValues'" == "" { // if outcome() specified, do not override
             if "`MarginsPredOpt'"=="" & "`MarginsExprOpt'"=="" {
                    local OverValues "*"
             }
         }
     }

    * default to all categories if plot option specified and outcome() is not
    if "`OverValues'" == "" & "`meanpred'" != "" {
        if "`MarginsPredOpt'"=="" & "`MarginsExprOpt'"=="" {
             local OverValues "*"
        }
    }

    * if * or _all, make outcome all outcome categories
    local OverValues = trim("`OverValues'")
    if "`OverValues'" == "*" | "`OverValues'" == "_all" {
        * levels of should not use if and in
        qui levelsof `e(depvar)' if e(sample)==1, local(OverValues)
    }

    * expand and sort outcome as numlist
    if "`OverValues'" != "" {
        numlist "`OverValues'", sort
        local OverValues "`r(numlist)'"
    }

//  if outcome() not specified, then only execute once

    if "`OverValues'" == "" | ///
        ("`MarginsPredOpt'"!="" & "`MarginsExprOpt'"!="") {

        `qui' margins `ifin',`MarginsOpts'
        local AtVarlist "`atvars'"
        if "`atvars'" == ""    {
            capture _GetVaryingAtList
            * default atvars() is variables for which at() varies
            local AtVarlist "`s(varyingat)'"
        }
        _MGen, stub(`StubName') atvars(`AtVarlist') ///
            `_MGenOpts' marginname(`predname') ///
            `replace'
        local newvarnms "`newvarnms'`s(svmatvarnms_fv)' "
    }

    * not overvalues and requires at matrix exists
    else if "`AtMatrixExists'" == "TRUE" {

        if "`MarginsPredOpt'"!="" | "`MarginsExprOpt'"!="" {
            display as error ///
            "predict() or expression() not allowed if outcome values specified"
            error 999
        }

        * determine whether cumulative should be used
        local DoCumulative "TRUE"
        * get levels of dependent variable; do not us if in conditions
        qui levelsof `e(depvar)' if e(sample) == 1, local(yAllLevels)

        * don't do cumulative if binary
        if ("`ExprType'"=="p") local DoCumulative "FALSE"

        * don't do cumulative if outcome levels aren't the lowest for category
        if "`ExprType'" == "outcome" {
            tokenize `yAllLevels'
            local count = 1
            foreach i of numlist `OverValues' {
                if (`i'!=``count'') local DoCumulative "FALSE"
                local ++count
            }
        }

        * if count, allow cum if it is a set of consecutive positive integers
        * starting with lowest observed value
        if "`ExprType'" == "pr" {
            local LengthOverValues: word count `OverValues'
            local MaxOverValues: word `LengthOverValues' of `OverValues'
            local MinOverValues: word 1 of `OverValues'
            * if not a set of consecutive positive integers, false
            if `LengthOverValues' != (`MaxOverValues'-`MinOverValues') + 1 {
                local DoCumulative "FALSE"
            }
            * if min value of overvalues not minimum value of outcome, no cum
            local yMin : word 1 of `yAllLevels'
            if (`MinOverValues'!=`yMin') local DoCumulative "FALSE"
        }

        foreach ival of numlist `OverValues' {

            if ("`LoopFirstTime'"=="") local LoopFirstTime "TRUE"
            else local LoopFirstTime "FALSE"

            * determine predict expression
            if "`ExprType'" == "outcome" { // if categorical
                local PredExpr = "predict(outcome(`ival'))"
            }
            else if "`ExprType'" == "pr" { // if count
                local PredExpr = "predict(pr(`ival'))"
            }
            * count + conditional specified
            else if "`ExprType'" == "pr" & "`conditional'" != "" {
                local PredExpr = "predict(cpr(`ival'))"
            }
            else if "`ExprType'" == "p" {  // if binary variable
                * should work for pr(0) inside margins expression
                if (`ival'==0) local PredExpr = "1-predict(p)"
                * pr != 0 in binary model
                else local PredExpr = "predict(p)"
            }
            else {
                display as error ///
                    "model predictions not compatible with outcome() option"
                error 999
            }

            * execute margins
            `qui' di _new "-> `e(depvar)' = `ival'"
*            `qui' margins, `MarginsOpts' expression(`PredExpr')
            `qui' margins `ifin', `MarginsOpts' expression(`PredExpr')
            local AtVarlist "`atvars'"
            if "`atvars'" == "" {
                capture _GetVaryingAtList
                * default atvars() is variables for which at() varies
                local AtVarlist "`s(varyingat)'"
            }

            * _MGen
            local OutcomeName "`e(depvar)'"
            local yLabelName : value label `OutcomeName'
            local iValueLabel ""
            if "`yLabelName'" != "" {
                local iValueLabel : label `yLabelName' `ival' `valuelength'
            }

            if "`LoopFirstTime'" == "TRUE" {
                _MGen, stub(`StubName') atvars(`AtVarlist') ///
                    `_MGenOpts' marginname(`predname') ///
                    ivalue(`ival') iname(`iValueLabel') ///
                    uselabels(`UseLabels') `replace'
                local newvarnms "`newvarnms'`s(svmatvarnms_fv)' "
            }
            else {
                _MGen, stub(`StubName') atvars(_none) ///
                    `_MGenOpts' marginname(`predname') ///
                    ivalue(`ival') iname(`iValueLabel') ///
                    uselabels(`UseLabels') `replace'
                local newvarnms "`newvarnms'`s(svmatvarnms_fv)' "
            }
            local bName "`s(bname)'"

            * generate cumulative probabilities
            if "`DoCumulative'" == "TRUE" {
                local bNewVar "`StubName'`bName'`ival'"
                local bVarNames " `bVarNames' `bNewVar'"
                local bNewCumVar "`StubName'C`bName'`ival'"
                if "`replace'"=="replace" {
                    capture drop `bNewCumVar'
                }
                qui egen `bNewCumVar' = rsum(`bVarNames') if `bNewVar' < .
                local newvarnms "`newvarnms'`bNewCumVar' "
                if "`LoopFirstTime'" == "TRUE" {
                    label var `bNewCumVar' "pr(y=`ival')"
                }
                else label var `bNewCumVar' "pr(y<=`ival')"

                * label cumulative probability variable with outcome label
                if "`iValueLabel'" != "" & "`UseLabels'" == "TRUE" {
                    if "`LoopFirstTime'" == "TRUE" {
                        label var `bNewCumVar' "pr(y=`iValueLabel')"
                    }
                    else label var `bNewCumVar' "pr(y<=`iValueLabel')"
                }
            }
            * label prob
            local icatnm "`ival'"
            if "`iValueLabel'" != "" & "`UseLabels'" == "TRUE" {
                local icatnm `iValueLabel'
            }
            if "`predlabel'" == "" {
                label var `StubName'`bName'`ival' ///
                    "`bName'(y=`icatnm') from margins"
            }
            else label var `StubName'`bName'`ival' "`predlabel'(y=`icatnm')"
        } // closes loop over all variables
    } // close else if "`AtMatrixExists'" == "TRUE" {

//  mean prediction plot option
//  NOTE: if and in conditions are not used in making computations

    if "`meanpred'" != "" {

        * generate empty variables -- values will be replaced in loop
        qui {
            if "`replace'"=="replace" {
                capture drop `StubName'val
                capture drop `StubName'obeq
                capture drop `StubName'oble
                capture drop `StubName'preq
                capture drop `StubName'prle
                capture drop `StubName'ob_pr
            }
            gen `StubName'val = .
            label var `StubName'val "`e(depvar)'"
            gen `StubName'obeq = .
            label var `StubName'obeq "Observed proportion"
            gen `StubName'oble = .
            label var `StubName'oble "Observed cum. proportion"
            gen `StubName'preq = .
            label var `StubName'preq "Predicted proportion"
            gen `StubName'prle = .
            label var `StubName'prle "Predicted cum. proportion"
            gen `StubName'ob_pr = .
            label var `StubName'ob_pr "Observed - Predicted"
            local newvarnms "`newvarnms'`StubName'val `StubName'obeq "
            local newvarnms "`newvarnms' `StubName'oble `StubName'preq "
            local newvarnms "`newvarnms' `StubName'prle `StubName'ob_pr "
            if "`conditional'" != "" & "`ExprType'" == "pr" {
                if "`replace'"=="replace" {
                    capture drop `StubName'cpreq
                    capture drop `StubName'cprle
                }
                gen `StubName'cpreq = .
                label var `StubName'cpreq "Avg predicted Pr(y=#|y>0)"
                gen `StubName'cprle = .
                label var `StubName'cprle "Avg predicted Pr(y<=#|y>0)"
                local newvarnms "`newvarnms' `StubName' `StubName'cprle "
            }
        }

        local yVarLabel : variable label `e(depvar)'
        if "`UseLabels'" == "TRUE" & "`yVarLabel'" != "" {
            label var `StubName'val "`yVarLabel'"
        }

        local Row = 0
        foreach ival of numlist `OverValues' {

            local ++Row
            if `Row'>`c(N)' { // set obs value in c(N)
                display as error ///
                "set obs # must equal or exceed the number of outcome values"
                exit
            }

            qui replace `StubName'val = `ival' in `Row' // value of count
            * observed probability (y=k)
            qui count if `e(depvar)'==`ival' & e(sample)==1
            local ObsFreq = r(N)
            qui count if e(sample)==1
            local TotalN = r(N)
            local ObsProb = `ObsFreq'/`TotalN'
            qui replace `StubName'obeq = `ObsProb' in `Row'

            * observed cumulative probability (sum of extant rows)
            qui sum `StubName'obeq
            qui replace `StubName'oble = r(sum) in `Row'

            * average predicted probability
            tempvar Pred
            if "`ExprType'" == "outcome" { // if categorical
                qui predict `Pred' if e(sample), outcome(`ival')
            }
            else if "`ExprType'" == "pr" { // if count
                qui predict `Pred' if e(sample), pr(`ival')
            }
            else if "`ExprType'" == "p" {  // if binary variable
                qui predict `Pred' if e(sample), p
                if `ival' == 0 {
                    qui replace `Pred' = 1 - `Pred'
                }
            }
            else {
                display as error ///
                    "model predictions not compatible with meanpred option"
                error 999
            }
            qui sum `Pred'
            local mean = r(mean)
            qui replace `StubName'preq = r(mean) in `Row'

            * observed cumulative probability
            qui sum `StubName'preq
            qui replace `StubName'prle = r(sum) in `Row'

            * observed - predicted
            qui replace `StubName'ob_pr = `StubName'obeq - `StubName'preq

            * average predicted probability y > 0
            if "`conditional'" != "" & "`ExprType'" == "pr" {
                capture drop `Pred'
                qui predict `Pred' if e(sample), cpr(`ival')
                label var `Pred' "Avg predicted Pr(y>0)"
                local newvarnms "`newvarnms'`Pred' "
                qui sum `Pred'
                local mean = r(mean)
                qui replace `StubName'cpreq = r(mean) in `Row'
                qui sum `StubName'cpreq
                qui replace `StubName'cprle = r(sum) in `Row'
            }

        } // close loop Overvalues

        * generate predictions from earlier as columns
        if "`AtMatrixExists'" == "TRUE" {

            local MinValue : word 1 of `OverValues'
            if "`MinValue'" != "" {

                qui count if `StubName'`bName'`MinValue' < .
                local RowsOfPreds = r(N)

                forvalues i = 1(1)`RowsOfPreds' {

                    * figure out what to append to every variable
                    * -- each row of predictions needs own variables
                    local Suffix "_at`i'"
                    if (`RowsOfPreds'==1) local Suffix "_at"

                    if "`replace'"=="replace" {
                        capture drop `StubName'`bName'`Suffix'
                    }
                    qui gen `StubName'`bName'`Suffix' = .

                    label var `StubName'`bName'`Suffix' "?"
                    local newvarnms "`newvarnms'`StubName'`bName'`Suffix' "
                    if "`DoCumulative'" == "TRUE" {
                        if "`replace'"=="replace" {
                            capture drop `StubName'C`bName'`Suffix'
                        }
                        qui gen `StubName'C`bName'`Suffix' = .
                        label var `StubName'C`bName'`Suffix' "?"
                        local newvarnms ///
                            "`newvarnms'`StubName'C`bName'`Suffix' "
                    }
                    if "`noci'"=="" | "`allstats'"!="" {
                        if "`replace'"=="replace" {
                            capture drop `StubName'`bName'`ulName'`Suffix'
                            capture drop `StubName'`bName'`llName'`Suffix'
                        }
                        qui gen `StubName'`bName'`ulName'`Suffix' = .
                        label var `StubName'`bName'`ulName'`Suffix' ///
                            "...upper bound"
                        local newvarnms ///
                            "`newvarnms' `StubName'`bName'`ulName'`Suffix'"
                        qui gen `StubName'`bName'`llName'`Suffix' = .
                        label var `StubName'`bName'`llName'`Suffix' ///
                            "...lower bound"
                        local newvarnms ///
                            "`newvarnms' `StubName'`bName'`llName'`Suffix'"
                    }
                    if "`allstats'" != "" {
                        if "`replace'"=="replace" {
                            capture drop `StubName'pval`Suffix'
                            capture drop `StubName'se`Suffix'
                            capture drop `StubName'z`Suffix'
                        }
                        qui gen `StubName'pval`Suffix' = .
                        label var `StubName'pval`Suffix' "...p-value"
                        local newvarnms "`newvarnms'`StubName'pval`Suffix' "
                        qui gen `StubName'se`Suffix' = .
                        label var `StubName'se`Suffix' "...standard errror"
                        local newvarnms "`newvarnms'`StubName'se`Suffix' "
                        qui gen `StubName'z`Suffix' = .
                        label var `StubName'z`Suffix' "...z-value"
                        local newvarnms "`newvarnms'`StubName'z`Suffix' "
                    }

                    local Row = 0
                    foreach j of numlist `OverValues' {
                        local ++Row
                        qui replace `StubName'`bName'`Suffix' ///
                            = `StubName'`bName'`j'[`i'] in `Row'
                        if "`DoCumulative'" == "TRUE" {
                            qui replace `StubName'C`bName'`Suffix' ///
                                = `StubName'C`bName'`j'[`i'] in `Row'
                        }
                        if "`noci'"=="" | "`allstats'"!="" {
                          qui replace `StubName'`bName'`ulName'`Suffix' ///
                                = `StubName'`bName'`ulName'`j'[`i'] in `Row'
                          qui replace `StubName'`bName'`llName'`Suffix' ///
                                = `StubName'`bName'`llName'`j'[`i'] in `Row'
                        }
                        if "`allstats'" != "" {
                            qui replace `StubName'pval`Suffix' ///
                                = `StubName'pval`j'[`i'] in `Row'
                            qui replace `StubName'se`Suffix' ///
                                = `StubName'se`j'[`i'] in `Row'
                            qui replace `StubName'z`Suffix' ///
                                = `StubName'z`j'[`i'] in `Row'
                        }
                    }
                }
            }
        } // if AtMatrixExists condition
    } // if plot option

    local cmd "margins `ifin', `MarginsOpts'"
    local cmd : subinstr local cmd "margins ," "margins,", all
    if ("`cmd'"=="margins, ") local cmd margins
    display _new "Variables computed with: `cmd'"
    codebook `newvarnms', compact
    return local newvars "`newvarnms'"

end

program define _MarginsParse, sclass

    syntax , [ ///
            post /// need to block margins post
            at(string asis) /// at option
            atmeans /// asmeans option
            PRedict(string asis) /// predict option
            EXPression(string asis) /// expression option
            *      /// everything else will get passed along
            ]

    if "`post'" != "" {
        display as error ///
            "posting margins results not allowed with mgen"
        error 999
    }

    * note if predict or expression options are used
    if "`predict'" != "" {
        sreturn local predictused "TRUE"
        local PredText "predict(`predict')"
    }
    if "`expression'" != "" {
        sreturn local expressionused "TRUE"
        local ExprText "expression(`expression')"
    }

    * note if at or atmeans used
    if "`at'" != "" {
        sreturn local atused "TRUE"
        local AtText "at(`at')"
    }
    if "`atmeans'" != "" {
        sreturn local atmeansused "TRUE"
    }

    * get rid of blanks in options
    local opt "`options' `AtText' `atmeans' `PredText' `ExprText'"
    local opt = ltrim("`opt'")
    local opt = rtrim("`opt'")
    local opt : subinstr local opt "  " " ", all
    sreturn local options `opt'

end

// determine type of model based on predict behavior

program define _GetModelType, sclass

    version 11.2

    syntax , [ force conditional ]

    local OutcomeName "`e(depvar)'"
    qui sum `OutcomeName'
    local MinValue = r(min)

    tempname TestVar DefaultPreds

    * obtain default values under predict; if in conditions not needed
    quietly predict `DefaultPreds'

    * test if an outcome() type prediction
    capture quietly predict `TestVar', outcome(`MinValue')
    if (_rc == 0) local ExprType "outcome"

    * test if an pr() type prediction
    if "`ExprType'" == "" {
        capture drop `TestVar'
        * note: have to use pr(0) here in case minvalue is non-integer
        capture quietly predict `TestVar', pr(0)
        if (_rc==0) local ExprType "pr"
        * if non integer count
        else if _rc == 198 & "`force'"=="force" {
            local ExprType "pr"
        }
    }

    * if conditional supported, test if predict allows conditional predictions
    if "`conditional'" != "" {
        capture drop `TestVar'
        capture quietly predict `TestVar', cpr(`MinValue')
        if _rc == 0 {
            display as err "conditional predictions not available"
            error 999
        }
    }

    * test if p type prediction; requires p is supported and equals default
    if "`ExprType'" == "" {
        capture drop `TestVar'
        capture quietly predict `TestVar', p
        if _rc == 0 {
            if `TestVar' == `DefaultPreds' { // p must be default
                local ExprType "p"
            }
        }
    }

    sreturn local expressiontype "`ExprType'"

end

program define _GetVaryingAtList, sclass

    version 11.2
    tempname VaryingMatrix
    qui mlistat, savevarying(`VaryingMatrix')

    capture _return drop _temporary
    _return hold _temporary

    cap confirm matrix `VaryingMatrix'

    if _rc == 0 { // only if varying at() value exists

        local ColumnNames : colnames `VaryingMatrix'
        local NumberOfColumns : word count `ColumnNames'

        forvalues i = 1(1)`NumberOfColumns' {
            _ms_element_info, element(`i') matrix(`VaryingMatrix')
            if strpos("`VaryingAtList'", " `r(term)' ") == 0 {
                local VaryingAtList " `r(term)' `VaryingAtList'"
            }
        }

        local VaryingAtList = trim("`VaryingAtList'")
        local VaryingAtList = itrim("`VaryingAtList'")

    }

    _return restore _temporary
    sreturn local varyingat "`VaryingAtList'"

end

program define _MGen, sclass

    version 11.2

    local test = 0 // local test = 1
    syntax  ,                   ///
        stub(string asis) /// variables with this name as stub
        [ ///
        replace ///
        statoptions(string asis) /// statstics options
        ATvars(string asis) /// select and rename r(at) variables
        ivalue(string asis) iname(string asis) uselabels(string asis) ///
        marginname(string asis) ///
        ulname(string asis) ///
        llname(string asis) ///
        mlabel(string asis) ///
        ]

    tempname table outmat ivec atuse atsrc
    local StubName "`stub'"

    local atoutnms ""
    capture confirm matrix r(at)
    local isat = 0
    if _rc==0 {
        local isat = 1
        matrix `atsrc' = r(at)
    }

    * locations for statistics: 1b 2se 3z 4pvalue 5ll 6ul
    local isse = 0
    local isz = 0
    local isp = 0
    local isci = 0
    if "`statoptions'" == "" {
        local stats "1 5 6"
        local isci = 1
    }
    if "`statoptions'" == "noci" {
        local stats "1"
    }
    if "`statoptions'"=="allstats" {
        local stats "1 2 3 4 5 6"
        local isse = 1
        local isz = 1
        local isp = 1
        local isci = 1
    }

    local CILevel = r(level)

    _rm_marginsinfo
    _rm_marginsnames
    local expdydx "`s(expdydx)'"
    if ("`marginname'"=="") local nm1 "`s(expname)'"
    else local nm1 "`marginname'"

    if "`nm1'"=="" { // 2013-07-03
        local nm1 "`s(predict)'"
        local nm1 : subinstr local nm1 "(" "", all
        local nm1 : subinstr local nm1 ")" "", all
        local nm1 : subinstr local nm1 " " "", all
    }
    local MarginName "`nm1'"
    local nm2 "se"
    local nm3 "z"
    local nm4 "pval"
    local nm5 "`nm1'`llname'"
    local nm6 "`nm1'`ulname'"
    local nm5 "`llname'"
    local nm6 "`ulname'"

    * estimates and statistics
    matrix `table' = r(table)'

    * if dydx for factor variable, remove 0b. rows
    * if dydx(i.var) r(b) has rows that are 0b. with 0's to be removed.
    if "`expdydx'"=="dydx" {
        * names of rows in predictions
        local rnms : rowfullnames `table'
        * which rows are for "0b." estimates
        tempname keepvec
        capture matrix drop `keepvec'
        local irow = 0
        foreach rnm in `rnms' {
            local ++irow
            *di "|`rnm'|"
            local isdrop = strpos("`rnm'","0b.")
            if `isdrop'<1 {
                matrix `keepvec' = nullmat(`keepvec') \ `irow'
            }
        }
        * extract rows to be kept
        _rm_matrix_index `table' `keepvec' row
    } // if dydx

    _rm_matrix_noomitted `table' row
    local colnms ""
    foreach i in `stats' {
        matrix `ivec' = `table'[1...,`i']
        matrix `outmat' = nullmat(`outmat') , `ivec'
        local colnms "`colnms' `stub'`nm`i''`ivalue'"
    }

    * at matrix
    if `isat' {
        if "`atvars'" == "" | "`atvars'"=="_all"  {
            matrix `atuse' = `atsrc'
        }
        else if ("`atvars'"=="_none") local isat = 0
        else {
            local atnms : colnames `atsrc'
            foreach atvarnm of local atvars {
                local ipos : list posof "`atvarnm'" in atnms

                if `ipos'==0 {
                    qui levelsof `atvarnm', local(fvlevels)
                    foreach fvval in `fvlevels' {

                        local errornotfv "yes"
                        local ipos : list posof "`fvval'.`atvarnm'" in atnms
                        if `ipos' == 0 {
                          local ipos : list posof "`fvval'b.`atvarnm'" in atnms
                        }
                        if `ipos' != 0 {
                            local errornotfv "no"
                            matrix `ivec' = `atsrc'[1..., `ipos']
                            matrix `atuse' = nullmat(`atuse'), `ivec'
                        }
                        if "`errornotfv'" == "yes" {
                            display as error ///
                            "`atvarnm' not in r(at) matrix: `atnms'"
                            error 111
                        }
                    }
                }
                else {
                    matrix `ivec' = `atsrc'[1...,`ipos']
                    matrix `atuse' = nullmat(`atuse') , `ivec'
                }
            }
        }
        if `isat' {
            local atnms : colnames `atuse'
            foreach nm in `atnms' {
                local atoutnms "`atoutnms'`StubName'`nm' "
            }
            matrix `outmat' = `outmat' , `atuse'
        }
    }

//  create variables

    local atoutnms : subinstr local atoutnms "." "_", all
    matrix colnames `outmat' = `colnms' `atoutnms'
    if "`replace'"=="replace" {
        foreach vnm in `colnms' `atoutnms' {
            capture drop `vnm'
        }
    }
    svmat `outmat', names(col)
    local svmatvarnms "`colnms' `atoutnms'"

//  label vars

    if `isci' {
        label var `StubName'ul`ivalue' "`CILevel'% upper limit"
        label var `StubName'll`ivalue' "`CILevel'% lower limit"
    }
    if `isse' label var `StubName'se`ivalue' "std error of `MarginName'"
    if `isp' label var `StubName'pval`ivalue' "p-value for test `MarginName'=0"
    if `isz' label var `StubName'z`ivalue' "z-value for test `MarginName'=0"
    local varlbl "`MarginName'"
    if ("`mlabel'"!="") local varlbl "`mlabel'"
    if ("`ivalue'"=="") label var `StubName'`MarginName' "`varlbl'"
    foreach xVarName in `atnms' {
        if "`xVarName'" != "_cons" {
            if strpos("`xVarName'", ".") == 0 { // not factor variable
                local xVarLabel : variable label `xVarName'
                if "`xVarLabel'"=="" {
                    label var `StubName'`xVarName' "`xVarName'"
                }
                else label var `StubName'`xVarName' "`xVarLabel'"
            }
        }
    }

// handle factor variables

    * macro will contain variable names with factor variable properly handled
    local svmatvarnms_fv "`svmatvarnms'"

    foreach xVarName in `atnms' {
        if strpos("`xVarName'", ".") != 0 { // factor variable

            local DotSpot = strpos("`xVarName'", ".")
            local fvVarName = substr("`xVarName'", `DotSpot'+1, .)

            if "`fvVarCheck`fvVarName''" == "" { // only gen variable once
                * generate variable stubname+fvname
                if "`replace'"=="replace" {
                    capture drop `StubName'`fvVarName'
                }
                gen `StubName'`fvVarName' = .
                local fvVarCheck`fvVarName' "no"
                local svmatvarnms_fv "`svmatvarnms_fv' `StubName'`fvVarName'"

                * label new variable
                local xVarLabel : variable label `fvVarName'
                if "`xVarLabel'" == "" {
                    label var `StubName'`fvVarName' "`fvVarName'"
                }
                else label var `StubName'`fvVarName' "`xVarLabel'"

            }

            * figure out value of factor variable
            local fvValue = substr("`xVarName'", 1, `DotSpot'-1)
            local fvValue = subinstr("`fvValue'", "b", "", .)
            local fvValue = subinstr("`fvValue'", "n", "", .) // 089

            * populate with values
            local xVarName = subinstr("`xVarName'", ".", "_", .)
            qui replace `StubName'`fvVarName' ///
                = `fvValue' if `StubName'`xVarName' == 1

            * drop factor variable
            drop `StubName'`xVarName'
            local svmatvarnms_fv : subinstr ///
                local svmatvarnms_fv "`StubName'`xVarName'" "", all
        }
    }

    sreturn local bname "`MarginName'"
    sreturn local svmatvarnms "`svmatvarnms'"
    sreturn local svmatvarnms_fv "`svmatvarnms_fv'"

end

exit
* version 0.2.6 2012-09-13 jf - minor fixes
* version 0.2.5 2012-09-12 jf
* version 0.5.5 2012-09-19 | freese long | adds conditional option; smarter behavior about whether to do cumulative probs
* version 0.5.4 2012-09-17 | freese long | variable creation bypassed if meanpred with no at matrix
* version 0.5.3 2012-09-17 | freese long | require at() or atmeans
* version 0.5.2 2012-09-17 | freese long | fix predict() expression() bug; meanpred option
* version 0.5.1 2012-09-15 | freese long | count if not integer
* version 0.5.0 2012-09-15 | freese long | first mgen
* version 0.6.4 2012-11-19 | freese long | variable labels
* version 0.6.3 2012-11-19 | freese long | margin names
* version 0.6.2 2012-11-02 | freese long | allow over()
* version 0.6.1 2012-09-26 | freese long | remove inert code
* version 0.6.0 2012-09-26 | freese long | remove mstore; use _rm_marginsinfo
* version 0.6.5 2012-11-20 | freese long | remove debug code
* version 0.6.7 2013-01-21 | freese long | minor cleanup
* version 0.6.6 2012-11-20 | freese long | fixed bug involving _cons and variable label
* version 0.7.3 2013-04-09 | freese long | sl missing predictions for i.wc
* version 0.7.2 2013-04-08 | freese long | sl allow nose option for margins
* version 0.7.1 2013-03-27 | freese long | sl trap if no r(at)
* version 0.7.0 2013-03-03 | freese long | sl revise options; clean code
* version 0.7.5 2013-04-28 | freese long | sl for counts local Row
* version 0.7.4 2013-04-10 | freese long | sl fix predlabel
* version 0.8.3  2013-07-06 | freese long | fixed bug with non-integer counts
* version 0.8.2a 2013-07-05 | freese long | sl
*    _rm_marginsinfo // to do: merge the infor these return
*    _rm_marginsnames
* version 0.8.2 2013-07-03 | freese long | sl label when predict name is blank
    * use _rm_marginsnames
* version 0.8.1 2013-05-10 | freese long | sl minor bug fixes
* version 0.8.0 2013-05-10 | freese long | sl if in
* version 0.8.5  2013-07-23 | freese long | naming tweaks; rclass r(ifin)
* version 0.8.4  2013-07-23 | freese long | works with factor variables in at()

