{smcl}
{* 2012-06-20 16.44 scott long}{...}
{hi:help XXX}{right:also see: {helpb mp}}
{hline}

{title:Title}

{p2colset 5 16 24 2}{...}
{p2col:{cmd:XXX} {hline 2}}XXX is | 20Jun2012{p_end}
{p2colreset}{...}

{marker overview}
{title:Overview}

{pstd}
{cmd:XXX} does what?
The command {help YYY:YYY} lets you what?

{pstd}
Para2.

{title:General syntax}

{p 4 18 2}
{cmd:XXX }[{it:XXX2}]{cmd:,} {it:options}
{p_end}

{p 8 10 2}
where {it:XXX2} is a?
If no name is specified, {bf:XXX3} is used.
{p_end}


{title:Table of contents}

    {help mpbase##savescalar:1. Saving scalars}
    {help mpbase##saveestimates:2. Saving estimates and related statistics}
    {help mpbase##equationnames:3. Using equation names}
    {help mpbase##generate:5. Generating variables from columns}
    {help mpbase##viewing:6. Viewing and saving}
    {help mpbase##utility:7. Utility options}


{title:Options}
{marker OPTION1}
{dlgtab:OPTION1}
{pstd}

{pstd}
Scalars in e-returns and r-returns are saved with {opt rreturns()} and {opt ereturns()}.
Scalars created by the user are saved with {opt user()}.
{p_end}

{pstd}
{ul:Scalars returns when specifying column names}
{p_end}

{p2colset 7 24 25 0}
{synopt:{opt r:returns([column_name1=] return_name1...)}}
Save {opt r(return_name#)} in column {it:return_name#}.
If {it:column_name#} is used, save the return in column {it:column_name#}.
For example, {cmd:rreturns(Mean=mean Var)} saves {bf:r(mean)} in column
{bf:Mean} and return {bf:r(Var)} in column {bf:Var}.
If the columns do not exist in {it:collect_matrix}, new columns are added.
If the column exists, information in that column is over-written.

{synopt:{opt e:returns([column_name1=] return_name1...)}}
Save scalar e-returns.
{p_end}

{p 5 5 2}
{ul:Scalars from {cmd:lincom} and {cmd:nlcom}}
{p_end}

{synopt:{opt r:returns( [ est | estimate | lb | ub | z | t | p ] )}}
{cmd:lincom} and {cmd:nlcom} estimate linear and nonlinear combinations
of estimates.
You can save the estimates and related statistics.
For example, after {cmd:lincom wc + hc}, you save the estimate, the lower
and upper bounds, and the p values with
{cmd:statsto, r(B_wchc=est LB=lb UB=ub p)}.
{p_end}

{p 5 5 2}
{ul:Scalars from {cmd:test} and {cmd:testnl}}
{p_end}

{synopt:{opt r:returns( [ chi2 | F | df | df_r | p ] )}}
Test results from {cmd:test} and {cmd:testnl} are saved using
the return names listed as options above.
You can rename the columns where results are stored. For example,
{cmd:statsto, r(pvalue=p)}
{p_end}

{pstd}
{ul:Specifying the row for scalars}
{p_end}
{p2colset 7 24 25 0}
{p2col:{opt row:select(row_name)}}
Scalars are saved in row {it:row_name}.
If it does not exist, it is added to {it:collect_matrix}.
If {cmd:rowselect()} is not specified, scalars are saved in a new row
{bf:Row}{it:#} where {it:#} is the row number.
The row where results are saved is called the {it:active row}.
{p_end}

{marker saveestimates}
{dlgtab:Collecting estimates}
{pstd}

{pstd}
Estimation commands return estimates to the matrix {cmd:e(b)};
{help margins} saves them to {cmd:r(b)} or {cmd:e(b)} when the {bf:post} option
is used.
Variances and covariances are returned to the matrices {cmd:e(V)} or {cmd:r(V)}.
{cmd:statsto} uses the returned information to estimate statistics you can save.
{p_end}

{pstd}
{ul:Specifying which statistics to save}
{p_end}

{synopt:{opt eb:returns([new_name1=] statistic1...)}}
Save {it:statistic#} in column {it:statistic#}; if
{it:new_name#} is indicated, save it in that column.
You can rename some statistics and not others:
{cmd:ebreturn(Beta=b pvalue=p z)}.
{cmd:rbreturn()} saves {cmd:margins} estimates using the same syntax.
{p_end}

{p 6 6 2}
The statistics that can be saved are:
{p_end}

{p2colset 10 23 22 12}{...}
{p2col :{marker stats}statistics}Description{p_end}
{p2line}
{p2col :{bf:b}}Estimates{p_end}
{p2col :{bf:est}}Same as {bf:b}{p_end}
{p2col :{bf:estimate}}Same as {bf:b}{p_end}
{p2col :{bf:expb}}Exponential of {bf:b}{p_end}
{p2col :{bf:or}}Odds ratio; same as {bf:expb}{p_end}
{p2col :{bf:orpct}}Percentage change in the odds: 100*({bf:expb}-1){p_end}
{p2col :{bf:lb}}Lower bound of confidence interval{p_end}
{p2col :{bf:ub}}Upper bound of confidence interval{p_end}
{p2col :{bf:p}}p-value{p_end}
{p2col :{bf:se}}Standard error{p_end}
{p2col :{bf:t}}t-value{p_end}
{p2col :{bf:z}}z-value{p_end}
{p2col :{bf:level}}Level used for confidence interval{p_end}
{p2line}

{pstd}
{ul:Selecting which estimates to collect}
{p_end}

{p 6 6 2}
The elements in {cmd:e(b)} or {cmd:r(b)} have names that you can see with
{cmd:matrix list e(b)} or {cmd:matrix list r(b)}.
{cmd:rowselect()} selects which estimates to save.
{p_end}

{synopt:{opt row:select(estimate_name1...)}}
Saved the named estimates in rows named {it:estimate_name#}.
{p_end}

{synopt:{opt row:select(new_name1=estimate_name1...[_rest])}}
Save the named estimates to rows named {it:new_name#}.
You can rename some estimates but not others:
{cmd:rowselect(IQ=iq Weight=wt age)}.
To keep the rest of the estimates without renaming, use {bf:_rest}:
{cmd:rows(IQ=iq Weight=wt age _rest)}. {bf:iq} is saved in row {bf:IQ} and
{bf:wt} in row {bf:Weight}, with the rest of the estimates saved in rows with
the estimate's name.
{p_end}

{p 5 5 2}
{ul:at() values from {bf:margins}}
{p_end}

{p 6 6 2}
{help margins} returns values of the regressors at which predictions
are made in the matrix {bf:r(at)} or {bf:e(at)}.
The columns have the names of the regressors.
{p_end}

{synopt:{opt at:returns([new_name1=] regressor1...[_rest])}}
Save column {it:regressor#} e(at)} to column {it:regressor#};
if {it:new_name1} is specified, save it to that column.
You can rename some columns and not others: {cmd:atreturns(age=x1 income)}.
To select the remaining columns without renaming add option {bf:_rest}.

{p 6 6 2}
The {opt rowselect()} option is used to select rows.
{p_end}


{marker equationnames}
{dlgtab:Equation names}

{pstd}
The row and column names in matrices are known as {it:simple names}.
In addition, each row and column can have an {it:equation name}.
The equation name appears before the simple name and ends with a colon.
For example: {bf:Eq1:Row1}.
Often {bf:e(b)} uses the parameter name as the simple name
with the equation name describing the part of the model associated with
the parameter. For example, from {cmd: ologit}:

{space 5} e(b)[1,9]
{space 10} warm: {space 3} warm: {space 3} warm: {space 3} cut1: {space 3} cut2: {space 3} cut3:
{space 10} yr89 {space 4} male {space 4} white {space 3} _cons {space 3} _cons {space 3} _cons
{space 5} y1 {space 1} .5239 {space 3} -.7332 {space 2} -.3911 {space 2} -2.465 {space 2} -.6309 {space 2} 1.261

{pstd}
{cmd:warm:} is the equation name for the estimates for {cmd:yr89},
{cmd:male}, and {cmd:white}. The {cmd:_cons} estiamtes have equation names
indicating which cutpont they are.
If we save estimates with equation names and then list the matrix,
the equation name is in bold on the left margin.

{pstd}
You can add your own equation names when saving results as a way to
document what is in your matrix and to distinguish similar information.
For example, you can save means for men and women in separate columns
that are labeled by equation names:

{space 8}{cmd:sum income if female}
{space 8}{cmd:statsto income, r(Women:Mean=mean) clear}
{space 8}{cmd:sum income if male}
{space 8}{cmd:statsto income, r(Men:Mean=mean) list}

{p 5 5 2}
{ul:Equation names in {cmd:statsto} options}
{p_end}

{synopt:{opt at:returns(eq_name#:new_name#=at_variable#...)}}
Save column {it:at_variable#} from {bf:r(at)} in column
{it:eq_name#:new_name#}.
{p_end}

{synopt:{opt eb:returns(eq_name#:new_name#=return_name#...)}}
Save {it:return_name#} in column eq_name#:new_name#.
The same syntax works for {cmd:rbreturns()}.
{p_end}

{synopt:{opt e:returns(eq_name#:new_name#=return_name#...)}}
Save {it:return_name#} in column {it:eq_name#:new_name#}.
This syntax also works for {cmd:rreturns()}
{p_end}

{synopt:{opt row:select(eq_name:row_name)}}
Save the scalars in row {it:eq_name:row_name}.
{p_end}

{synopt:{opt row:select(eq_name1:new_name1=name1...)}}
The estimate {it:name#} is saved in row {it:eq_name#:new_name#}.
{p_end}

{p 5 5 2}
{ul:Adding equation names to all new rows or columns}
{p_end}

{synopt:{opt coleq:stub(column_stub)}}
Add the equation name {it:column_stub} to all incoming columns.
For example, {opt statsto, ebreturn(b p)  coleqstub("Model 1")}
adds add "Model 1" above columns "b" and "p."
{p_end}

{synopt:{opt roweq:stub(row_stub)}}
Add the equation name {it:row_stub} to all incoming rows.
For example, {opt statsto, ebreturn(b p) roweqstub("Model  1")} adds "Model 1"
beside all incoming rows.
{p_end}

{marker generate}
{dlgtab:Generating variables from columns}
{pstd}

{pstd}
You can create variables from the columns of your matrix.
This is particularly useful with {help margins} to save to plot.
{p_end}

{synopt:{opt gen:erate(column_list | column_numbers | _all)}}
Variables are generated from the specified columns with names
corresponding to the column names.
{bf:_all} selects all columns.
If the {bf:transpose} option is used, variables are created from the rows.
If the matrix has equation names, refer to columns by their number rather than
their name.
{p_end}

{marker viewing}
{dlgtab:Viewing and saving}
{pstd}

{pstd}
You can view the collection matrix with formatting and save the matrix
with a new name.
You can also save the {it:collection_matrix} with a new name, for example, if
you want to save intermediate results.
More elaborate options for viewing, rearranging, renaming, and deleting rows and
columns are available with {help statout}.
{p_end}

{synopt:{opt list}} List {it:collect_matrix} to the command window. {p_end}

{synopt:{opt dec:imal(numlist)}} Set the number of decimal digits
for each column when listing the matrix.
Columns can have different numbers of decimal digits.
For example, {cmd:statsto, list decimal(3 2)}.
{p_end}

{synopt:{opt format(string)}} Indicate the {help format} to use for each
column when listing the matrix.
For example, {cmd:statsto, list format(%9.2e %12.4e)}.
{p_end}

{synopt:{opt width(number)}} Specify the width of all columns.
{p_end}

{synopt:{opt title(title_string)}} Display {it:title_string}
above the matrix.{p_end}

{synopt:{opt tran:spose}} Temporarily transpose the matrix
before it is displayed.
{p_end}

{synopt:{opt prev:iew}} Display {it:collect_matrix} showing what the
matrix would like like after the current statistics are collected.
Those changes are not saved.
{p_end}

{synopt:{opt save(new_matrix_name)}} Save {it:collect_matrix} as a
matrix named {it:new_matrix_name}.
If {bf:transpose} is used, the transposed matrix is saved.
{p_end}

{marker utility}
{dlgtab:Utility options}
{pstd}

{synopt:{opt blank}} Add a blank row to {it: collect_matrix}.{p_end}

{synopt:{opt clear}} Remove {it:collect_matrix} from memory
before saving results.
For example, to create a new matrix you could use
{cmd:statsto mymat, eb(b) clear}.
If {bf:mymat} is a matrix in memory, it is removed before creating
a new {bf:mymat}.
{p_end}

{synopt:{opt colstub(stub)}} Add {it:stub} to the front
of all column names. This is useful if you are saving the same type
of information from multiple sources.
For example, {cmd:colstub(M1)} puts M1 in front of the names of
the new columns.
{p_end}

{synopt:{opt rowstub(stub)}} Add the prefix {it:stub} to the front
of all row names.
{p_end}

{synopt:{opt level(number)}} Set the significance level used when calculating
upper and lower bounds. Must be between 10 and 99.999.
{p_end}

{synopt:{opt mv(. | .a | .b |...)}} Select the type of missing values to
using in blank cells of {it: matrix_name}.
When adding information to {it: matrix_name}, cells that do not have a
value assigned will contain missing values.
By default .z is used which displays as a blank space.
You can fill empty cells with other types of missing values.{p_end}


{title:Authors}

{pstd}
Joseph D. Wolfe, Indiana University, jdwolfe@indiana.edu

{pstd}
Scott Long, Indiana University, jslong@indiana.edu

{title:Also see}

{pstd}
Manual: {hi:[M] matrix}

{pstd}
Website: {browse "http://www.indiana.edu/~jslsoc/web_collect/collect_home.htm":Collect Website}
